#pragma warning(disable:4996)
#include	<AjrCstXX.h>
#include	<shlwapi.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tchar.h>
#include	<varargs.h>
#include	<dbghelp.h>

#define	print_log(FMT, ...)		if (!fSilent) AjcPrintF(FMT, __VA_ARGS__)
#define	print_err(FMT, ...)		AjcErrPrintF(FMT, __VA_ARGS__);


//--------------------------------------------------------------------------------------------------------------//
//	wveLXg																								//
//--------------------------------------------------------------------------------------------------------------//
const static UT HelpTextJ[] =	TEXT("tH_\At@CRs[܂B\n")
								TEXT(" --- R}h` ----------------------------------\n")
								TEXT(" ExCopy  /I=Rs[tH_  /O=Rs[tH_  [IvV]EEE\n\n")
								TEXT(" ExCopy  /? iwveLXg\j\n\n")
								TEXT(" ExCopy     ȉꍇ́Ap^R\[́j\n\n")
								TEXT(" --- IvV̌` ------------------------------\n")
								TEXT(" /C                      Rs[OɃRs[tH_N[Abv\n")
								TEXT(" /CQ                     tH_N[AbvA₢킹Ȃ\n")
								TEXT(" /A                      A[JCut@Ĉ݂ΏۂƂ\n")
								TEXT(" /M                      A[JCut@Ĉ݂ΏۂƂA\n")
								TEXT(" /D                      tV^Rs[ɖt@Ĉ݃Rs[\n")
								TEXT(" /Q                      Rs[̏󋵂Oo͂܂\n")
								TEXT(" /T                      tH_\̂݃Rs[܂\n")
								TEXT(" /PF=t@C            p^Et@Cw肵܂\n")
								TEXT("\n")
								TEXT(" /DINC=ChJ[h    Rs[tH_̃ChJ[h\n")
								TEXT(" /DEXC=ChJ[h    OtH_̃ChJ[h\n")
								TEXT(" /DR=;V       tH_ύX\n")
								TEXT(" /DRT=ړ;Vړ  tH_̐ړύX\n")
								TEXT(" /DRS=;V  tH_̕ϊ\n")
								TEXT("\n")
								TEXT(" /FINC=ChJ[h    Rs[t@C̃ChJ[h\n")
								TEXT(" /FEXC=ChJ[h    Ot@C̃ChJ[h\n")
								TEXT(" /FR=;V       t@CύX\n")
								TEXT(" /FRT=ړ;Vړ  t@C̐ړύX\n")
								TEXT(" /FRS=;V  t@C̕ύX");

const static UT HelpTextE[] =	TEXT("Copy the folder structure and files.\n")
								TEXT("--- Command Format --------------------------------\n")
								TEXT(" ExCopy  SourceDirectry  DestinationDirectory  [Option]...\n")
								TEXT(" ExCopy  /? (Show Help.)\n")
								TEXT(" ExCopy     (If no arguments, enter the parameters from the console)\n\n")
								TEXT("--- Options  --------------------------------------\n")
								TEXT(" /C                      Clean up the destination folder before copying.\n")
								TEXT(" /CQ                     Clean up folders and don't ask.\n")
								TEXT(" /A                      Only for archive files.\n")
								TEXT(" /M                      Only for archive files and release attribute.\n")
								TEXT(" /D                      Copy only files with new date / not in destination.\n")
								TEXT(" /Q                      Does not log the status during copying.\n")
								TEXT(" /T                      Copy only the folder structure.\n")
								TEXT(" /PF=<FilePath>          Specify the parameter file.\n")
								TEXT("\n")
								TEXT(" /DINC=<WildCard>        Wildcards for folders to copy.\n")
								TEXT(" /DEXC=<WildCard>        Wildcards for folders to exclude.\n")
								TEXT(" /DR=<OldName>;<NewName>       Rename folder.\n")
								TEXT(" /DRT=<OldPrefix>;<NewPrefix>  Prefix of folder name to change.\n")
								TEXT(" /DRS=<OldString>;<NewString>  Change string in the folder name.\n")
								TEXT("\n")
								TEXT(" /FINC=<WildCard>        Wildcards for files to copy.\n")
								TEXT(" /FEXC=<WildCard>        Wildcards for files to exclude.\n")
								TEXT(" /FR=<OldName>;<NewName>       Rename file.\n")
								TEXT(" /FRT=<OldPrefix>;<NewPrefix>  Prefix of file name to change.\n")
								TEXT(" /FRS=<OldString>;<NewString>  String of folder name to change.");

const static UT HelpConJ[] =	TEXT("\n\n")
								TEXT(" /*                      R\[瑱̃p^͂B\n")
								TEXT(" /W=nnn                  R\[ECh̕()\n")
								TEXT(" /H=nnn                  R\[ECh̍(s)\n")
								TEXT(" /B=nnn                  R\[̃obt@s\n");

const static UT HelpConE[] =	TEXT("\n\n")
								TEXT(" /*                      Enter the following parameters from the console.\n")
								TEXT(" /W=nnn                  Console window width (number of characters)\n")
								TEXT(" /H=nnn                  Console window height (number of lines)\n")
								TEXT(" /B=nnn                  Number of console buffer lines\n");

//--------------------------------------------------------------------------------------------------------------//
//	p^																								//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL		fCleanUp	= FALSE;			//	/C
static	BOOL		fDontAsk	= FALSE;			//	/CQ
static	BOOL		fArc		= FALSE;			//	/A
static	BOOL		fArcRes		= FALSE;			//	/M
static	BOOL		fChkDate	= FALSE;			//	/D
static	BOOL		fSilent		= FALSE;			//	/Q
static	BOOL		fOnlyStruct	= FALSE;			//	/T
static	BOOL		fConInp		= FALSE;			//	/*
static	UI			ConWidth	= 0;				//	/W=nnn
static	UI			ConHeight	= 0;				//	/H=nnn
static	UI			ConBufSz	= 0;				//	/B=nnn
static	HAJCSPL		hSplDInc	= NULL;				//	/DINC=ChJ[h(Dir INClude)
static	HAJCSPL		hSplDExc	= NULL;				//	/DEXC=ChJ[h(Dir EXClude)
static	HAJCAVS		hAvsDR	 	= NULL;				//	/DR=;V	  (Dir Rename)
static	HAJCAVS		hAvsDRT 	= NULL;				//	/DRT=ړ;Vړ(Dir Rename by Top of name string)
static	HAJCAVS		hAvsDRS 	= NULL;				//	/DRS=;V(Dir Rename by String in name)
static	HAJCSPL		hSplFInc	= NULL;				//	/FINC=ChJ[h(File INClude)
static	HAJCSPL		hSplFExc	= NULL;				//	/FEXC=ChJ[h(File EXClude)	
static	HAJCAVS		hAvsFR	 	= NULL;				//	/FR=;V	  (File Rename)
static	HAJCAVS		hAvsFRT 	= NULL;				//	/FRT=ړ;Vړ(File Rename by Top of name string)
static	HAJCAVS		hAvsFRS 	= NULL;				//	/FRS=;V(File Rename by String in name)
static	UT			szParamFile[MAX_PATH] = {0};	//	/PF=t@C

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL		fParamErr = FALSE;				//	p^G[otO
static	BOOL		fFind;							//	Rs[ΏۃtH_^t@CʃtO
static	HAJCSPL		hSplPF	  = NULL;				//	v[ip^t@Cdw`FbNpj
static	UT			SrcDir[MAX_PATH];				//	Rs[tH_pX
static	UT			DstDir[MAX_PATH];				//	Rs[tH_pX

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO	CALLBACK AnalParameter(int argc, UT *argv[], C_UTP pTxt, UX cbp);
static	VO		AnalParamFile(C_UTP path);
static	VO		RegistSpl(HAJCSPL hSpl, C_UTP pStr);
static	VO		RegistAvs(HAJCAVS hAvs,   UTP pStr);
static	BOOL	CALLBACK cbCleanUp		(C_UTP pPathRemoved, BOOL fDir, UX cbp);
static	UTP		CALLBACK cbDirQuery		(C_UTP pPathFront, UTP pNewDir, UX cbp);
static	BOOL	CALLBACK cbDirNotify	(C_UTP pPathFrom, C_UTP pPathTo, EAJCCFS ntc, UX cbp);
static	UTP		CALLBACK cbFileQuery	(C_UTP pFileFrom, C_UTP pFileTo, UTP pFileName, UIP pAtt, UX cbp);
static	BOOL	CALLBACK cbFileNotify	(C_UTP pFileFrom, C_UTP pFileTo, EAJCCFS ntc, UX cbp);
static	BOOL	CALLBACK cbSplEnum 		(C_UTP pStr, UX cbp);
static	BOOL	CALLBACK cbAvsEnumMatch (C_UTP pKey, VOP pNodeData, UI len, UI nest, UX cbp);
static	BOOL	CALLBACK cbAvsEnumTop	(C_UTP pKey, VOP pNodeData, UI len, UI nest, UX cbp);
static	BOOL	CALLBACK cbAvsEnumStr	(C_UTP pKey, VOP pNodeData, UI len, UI nest, UX cbp);
static	VO		SetAbsPath(C_UTP pPath, UTP pBuf);

//--------------------------------------------------------------------------------------------------------------//
//	l`hm																									//
//--------------------------------------------------------------------------------------------------------------//
int main(int argc, UT *argv[])
{
	int		rc = 0;

	//	UNICODEAChɕϊ
	MAjcAllocMainArgs(argc, argv);

	do {
		//	ݒ
		if ((hSplDInc = AjcSplCreate(AJCCMP_IGNORE_WIDTH		 )) == NULL) break;
		if ((hSplDExc = AjcSplCreate(AJCCMP_IGNORE_WIDTH		 )) == NULL) break;
		if ((hAvsDR   = AjcAvsCreate(AJCCMP_IGNORE_WIDTH, 0, NULL)) == NULL) break;
		if ((hAvsDRT  = AjcAvsCreate(AJCCMP_IGNORE_WIDTH, 0, NULL)) == NULL) break;
		if ((hAvsDRS  = AjcAvsCreate(AJCCMP_IGNORE_WIDTH, 0, NULL)) == NULL) break;
		if ((hSplFInc = AjcSplCreate(AJCCMP_IGNORE_WIDTH		 )) == NULL) break;
		if ((hSplFExc = AjcSplCreate(AJCCMP_IGNORE_WIDTH		 )) == NULL) break;
		if ((hAvsFR   = AjcAvsCreate(AJCCMP_IGNORE_WIDTH, 0, NULL)) == NULL) break;
		if ((hAvsFRT  = AjcAvsCreate(AJCCMP_IGNORE_WIDTH, 0, NULL)) == NULL) break;
		if ((hAvsFRS  = AjcAvsCreate(AJCCMP_IGNORE_WIDTH, 0, NULL)) == NULL) break;
		if ((hSplPF   = AjcSplCreate(AJCCMP_IGNORE_WIDTH		 )) == NULL) break;

		//	p^
		if (argc >= 2) {				//	p^H
			if (MAjcStrCmp(argv[1], TEXT("/?")) == 0) {
				print_log(AJCLNGSEL(HelpTextJ, HelpTextE));
				print_log(AJCLNGSEL(HelpConJ , HelpConE ));
				print_log(TEXT("\n"));
				break;
			}
			else {
				AnalParameter(argc - 1, &argv[1], GetCommandLine(), 0);
			}
		}
		//	R\[̃EChTCYƃobt@TCYݒ
		{
			UI		l, t, r, b;
			UI		cx, cy;
			if (ConWidth != 0 || ConHeight != 0 || ConBufSz != 0) {
				AjcGetConsoleWndRect(&l, &t, &r, &b);
				AjcGetConsoleBufSize(&cx, &cy);
				if (ConWidth  > (r - l + 1)) r  = l + ConWidth  - 1;
				if (ConHeight > (b - t + 1)) b  = t + ConHeight - 1;
				if (ConBufSz  > cy         ) cy = ConBufSz;
				AjcSetConsoleBufSize(r - l + 1, cy);
				AjcSetConsoleWndRect (l, t, r, b);
			}
		}
		//	R\[
		if (argc <= 1 || fConInp) {		//	p^Ȃ or u/*vw肠H
			int		i;
			BOOL	f1st = TRUE;
			UT		buf[2048] = {0};
			//	̓eLXgݒ
			for (i = 1; i < argc; i++) {
				if (MAjcStrNICmp(argv[i], TEXT("/W="), 3) != 0 &&
					MAjcStrNICmp(argv[i], TEXT("/H="), 3) != 0 &&
					MAjcStrNICmp(argv[i], TEXT("/B="), 3) != 0 &&
					MAjcStrICmp (argv[i], TEXT("/*")    ) != 0) {
					if (!f1st) _tcscat_s(buf, 2048, TEXT(" "));
					_tcscat_s(buf, 2048, argv[i]);
					f1st = FALSE;
				}
			}
			//	R\[
			print_log(AJCLNGSEL(TEXT(" p^(FO͒lQƁCESCFI)\n "),
								TEXT(" Please enter the parameters.\n ")));
			if (!AjcConInputEx(buf, 512, buf, AJCTSIZE(buf), AJCCIN_SHOWPREV, -1, -1, AJCLNGSEL(HelpTextJ, HelpTextE), 0, AnalParameter)) {
				break;
			}
		}

		do {
			//	Rs[tH_`FbN
			if		(SrcDir[0] == 0) {
				print_err(AJCLNGSEL(TEXT(" G[: Rs[tH_w肳Ă܂B\n"),
									TEXT(" Error: The copy source folder is not specified.\n")));
				fParamErr = TRUE;
				break;
			}
			else if (!AjcPathIsDirectory(SrcDir)) {
				print_err(AJCLNGSEL(TEXT(" G[: Rs[tH_܂B(%s)\n"),
									TEXT(" Error: Source folder not found.(%s)\n")), SrcDir);
				fParamErr = TRUE;
			}
			//	Rs[ƃRs[悪tH_`FbN
			if (MAjcStrICmp(SrcDir, DstDir) == 0) {
				print_err(AJCLNGSEL(TEXT(" G[: Rs[ƃRs[tH_łB(%s)\n"),
									TEXT(" Error: The copy source and copy destination folders are the same.(%s)\n")), DstDir);
				fParamErr = TRUE;
				break;
			}
			//	Rs[tH_`FbN
			if		(DstDir[0] == 0) {
				print_err(AJCLNGSEL(TEXT(" G[: Rs[tH_w肳Ă܂B\n"),
									TEXT(" Error: The copy destination folder is not specified.\n")));
				fParamErr = TRUE;
				break;
			}
			else if (!AjcPathIsDirectory(DstDir)) {
				//	Rs[tH_
				BC	tmp[MAX_PATH];
				strcpy(tmp, DstDir);
				AjcPathCat(tmp, "", MAX_PATH);
				if (!MakeSureDirectoryPathExists(tmp)) {
					print_err(AJCLNGSEL(TEXT(" G[: Rs[tH_̐s܂B(%s)\n"),
										TEXT(" Error: Destination folder creation failure.(%s)\n")), DstDir);
					fParamErr = TRUE;
					break;
				}
			}
		} while(0);
		//	p^G[Ȃ΁A~
		if (fParamErr) break;

		//	Rs[tH_N[Abv
		if (fCleanUp && !PathIsDirectoryEmpty(DstDir)) {
			if (!fDontAsk) {
				UT		txt[512];
				AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("tH_N[Abv܂B낵łH\n(%s)"),
														  TEXT("Clean-up the folder. Are you sure?\n(%s)")), DstDir);
				if (MessageBox(NULL, txt, TEXT("ExCopy"), MB_YESNO) == IDNO) {
					break;
				}
			}
			print_log(TEXT("\n"));
			print_log(AJCLNGSEL(TEXT(" tH_ N[Abv(%s)\n"), TEXT(" - Folder cleanup.(%s)\n")), DstDir);
			AjcCleanFolder(DstDir, 0, cbCleanUp);
		}

		print_log(TEXT("\n"));
		print_log(AJCLNGSEL(TEXT(" tH_\^t@C Rs[\n"), TEXT("- Copy folder structure and files.\n")));

		//	ŏʃtH_̃t@CRs[s
		if (!fOnlyStruct) {
			AjcCopyFilesEx(SrcDir, DstDir, TEXT("*.*"), TRUE, 0, cbFileNotify, cbFileQuery);
		}

		//	TutH_̃tH_\Ct@CRs[s
		AjcCopyFolderStructEx(SrcDir, DstDir, AJCFSC_FORCETIME, 0, cbDirNotify, cbDirQuery);

	} while(0);


	//	㏈
	if (hSplDInc != NULL) AjcSplDelete(hSplDInc);
	if (hSplDExc != NULL) AjcSplDelete(hSplDExc);
	if (hAvsDR	 != NULL) AjcAvsDelete(hAvsDR  );
	if (hAvsDRT  != NULL) AjcAvsDelete(hAvsDRT );
	if (hAvsDRS  != NULL) AjcAvsDelete(hAvsDRS );
	if (hSplFInc != NULL) AjcSplDelete(hSplFInc);
	if (hSplFExc != NULL) AjcSplDelete(hSplFExc);
	if (hAvsFR	 != NULL) AjcAvsDelete(hAvsFR  );
	if (hAvsFRT  != NULL) AjcAvsDelete(hAvsFRT );
	if (hAvsFRS  != NULL) AjcAvsDelete(hAvsFRS );
	if (hSplPF	 != NULL) AjcSplDelete(hSplPF  );

	//	UNICODEAXg
	MAjcFreeMainArgs(argc, argv);

	printf("\nHit Enter Key!!");
	getchar();

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	p^																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO	CALLBACK AnalParameter(int argc, UT *argv[], C_UTP pTxt, UX cbp)
{
	int		i;

	if (argc >= 1) {
		//	/QIvV`FbN
		for (i = 0; i < argc; i++) {
			if (MAjcStrICmp(argv[i], TEXT("/Q")) == 0) {fSilent = TRUE;}
		}
		//	IvV
		if (!fSilent) printf("\n");
		for (i = 0; i < argc; i++) {
			print_log(TEXT("   Option : %s\n"), argv[i]);
			if		(MAjcStrNICmp(argv[i], TEXT("/I=")	  , 3) == 0) {SetAbsPath(argv[i] + 3, SrcDir);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/O=")	  , 3) == 0) {SetAbsPath(argv[i] + 3, DstDir);		}
			else if	(MAjcStrICmp (argv[i], TEXT("/C")		 ) == 0) {fCleanUp		= TRUE;					}
			else if	(MAjcStrICmp (argv[i], TEXT("/CQ")		 ) == 0) {fCleanUp		= TRUE;	fDontAsk = TRUE;}
			else if	(MAjcStrICmp (argv[i], TEXT("/A")		 ) == 0) {fArc 			= TRUE;					}
			else if (MAjcStrICmp (argv[i], TEXT("/M")		 ) == 0) {fArc 			= TRUE; fArcRes = TRUE;	}
			else if (MAjcStrICmp (argv[i], TEXT("/D")		 ) == 0) {fChkDate		= TRUE;					}
			else if (MAjcStrICmp (argv[i], TEXT("/Q")		 ) == 0) {fSilent		= TRUE;					}
			else if (MAjcStrICmp (argv[i], TEXT("/T")		 ) == 0) {fOnlyStruct	= TRUE;					}
			else if (MAjcStrNICmp(argv[i], TEXT("/PF=")   , 4) == 0) {AnalParamFile(argv[i] + 4);			}
			else if (MAjcStrNICmp(argv[i], TEXT("/DINC=") , 6) == 0) {RegistSpl(hSplDInc, argv[i] + 6);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/DEXC=") , 6) == 0) {RegistSpl(hSplDExc, argv[i] + 6);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/DR=" )  , 4) == 0) {RegistAvs(hAvsDR	, argv[i] + 4);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/DRT=")  , 5) == 0) {RegistAvs(hAvsDRT , argv[i] + 5);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/DRS=")  , 5) == 0) {RegistAvs(hAvsDRS , argv[i] + 5);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/FINC=") , 6) == 0) {RegistSpl(hSplFInc, argv[i] + 6);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/FEXC=") , 6) == 0) {RegistSpl(hSplFExc, argv[i] + 6);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/FR=" )  , 4) == 0) {RegistAvs(hAvsFR	, argv[i] + 4);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/FRT=")  , 5) == 0) {RegistAvs(hAvsFRT , argv[i] + 5);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/FRS=")  , 5) == 0) {RegistAvs(hAvsFRS , argv[i] + 5);		}
			//	R\[TCYw
			else if (MAjcStrNICmp(argv[i], TEXT("/W="  )  , 3) == 0) {ConWidth  = _ttoi(argv[i] + 3);		}
			else if (MAjcStrNICmp(argv[i], TEXT("/H="  )  , 3) == 0) {ConHeight = _ttoi(argv[i] + 3);		}
			//	R\[obt@TCYw
			else if (MAjcStrNICmp(argv[i], TEXT("/B="  )  , 3) == 0) {ConBufSz  = _ttoi(argv[i] + 3);		}
			//	R\[͎w
			else if (MAjcStrICmp (argv[i], TEXT("/*")        ) == 0) {fConInp = TRUE;						}
			else {
				print_err(AJCLNGSEL(TEXT(" G[: sȃp^łB(%s)\n"), TEXT(" Error: Invalid parameter.(%s)\n")), argv[i]);
				fParamErr = TRUE;
			}
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	p^t@C																						//
//--------------------------------------------------------------------------------------------------------------//
static	VO	AnalParamFile(C_UTP path)
{
	HAJCFILE	hInp = NULL;
	UI			argc;
	UTP			*argv;
	UTP			p;
	UT			buf[1024];

	if (AjcSplFind(hSplPF, path) == NULL) {
		//	p^t@Co^
		AjcSplRegist(hSplPF, path);
		//	p^t@Cǂݏo
		if (hInp = AjcFOpen(path, AJCTEC_AUTO)) {
			while (AjcFGetS(hInp, buf, AJCTSIZE(buf))) {
				//	R[h󔒂ɕϊ
				for (p = buf; *p != 0; p++) {
					if (MAjcIsCntrl(*p)) *p = ' ';
				}
				//	p^
				if (argv = AjcParseCmdArgs(buf, &argc)) {
					AnalParameter(argc, argv, GetCommandLine(), 0);
					AjcReleaseCmdArgs(argv);
				}
			}
			AjcFClose(hInp);
		}
		else {
			print_err(AJCLNGSEL(TEXT(" G[: p^t@CI[vł܂B(%s)\n"),
								TEXT(" Error: Parameter open failure.(%s)\n")), path);
			fParamErr = TRUE;
		}
	}
	else {
		print_err(AJCLNGSEL(TEXT(" G[: p^t@CdɎw肳Ă܂B(%s)\n"),
							TEXT(" Error: Parameter files are duplicate specified..(%s)\n")), path);
		fParamErr = TRUE;
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	p^(/XXX=String)																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO	RegistSpl(HAJCSPL hSpl, C_UTP pStr)
{
	if (*pStr != 0) {
		AjcSplRegist(hSpl, pStr);
	}
	else {
		print_err(AJCLNGSEL(TEXT(" G[: sȃp^łB(%s)\n"),
							TEXT(" Error: Invalid parameter.(%s)\n")), pStr);
		fParamErr = TRUE;
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	p^(/XXX=String;String)																			//
//--------------------------------------------------------------------------------------------------------------//
static	VO	RegistAvs(HAJCAVS hAvs, UTP pStr)
{
	UTP		pOld;
	UTP		pNew;

	if ((pOld = MAjcStrTok(pStr, TEXT(";"))) != NULL && *pOld != 0) {
		if ((pNew = MAjcStrTok(NULL, TEXT(";"))) == NULL) pNew = TEXT("");
		AjcAvsInsNode(hAvs, pOld, (C_VOP)pNew, MAjcStrBytes(pNew));
	}
	else {
		print_err(AJCLNGSEL(TEXT(" G[: sȃp^łB(%s)\n"),
							TEXT(" Error: Invalid parameter.(%s)\n")), pStr);
		fParamErr = TRUE;
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	fBNg폜ʒm																						//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbCleanUp(C_UTP pPathRemoved, BOOL fDir, UX cbp)
{
	if (fDir) print_log(AJCLNGSEL(TEXT("   tH_폜܂B(%s)\n"), TEXT(" Folder removed (%s)\n")), pPathRemoved);
	else	  print_log(AJCLNGSEL(TEXT("   t@C폜܂B(%s)\n"), TEXT(" Folder removed (%s)\n")), pPathRemoved);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
//	fBNgRs[ہ^̕ύX̖₢킹																//
//--------------------------------------------------------------------------------------------------------------//
static	UTP CALLBACK cbDirQuery(C_UTP pPathFront, UTP pNewDir, UX cbp)
{
	UTP		pNewName = pNewDir;

	do {
		//	Rs[ΏۃtH_`FbNi /DINC: IvVj
		if (AjcSplNumber(hSplDInc) != 0) {
			fFind = FALSE;
			AjcSplEnumStr(hSplDInc, (UX)pNewName, cbSplEnum, FALSE);
		}
		else {
			fFind = TRUE;
		}
		if (!fFind) {pNewName = NULL; break;}

		//	Rs[ΏۊOtH_`FbNi /DEXC: IvVj
		if (AjcSplNumber(hSplDExc) != 0) {
			fFind = FALSE;
			AjcSplEnumStr(hSplDExc, (UX)pNewName, cbSplEnum, FALSE);
		}
		else {
			fFind = FALSE;
		}
		if (fFind) {pNewName = NULL; break;}

		//	̈vɂtH_ύXi /DR: IvVj
		AjcAvsEnumNodesEx(hAvsDR, (UX)pNewName, cbAvsEnumMatch, FALSE);

		//	ړɂtH_ύXi /DRT: IvVj
		AjcAvsEnumNodesEx(hAvsDRT, (UX)pNewName, cbAvsEnumTop, FALSE);

		//	ɂtH_ύXi /DRS: IvVj
		AjcAvsEnumNodesEx(hAvsDRS, (UX)pNewName, cbAvsEnumStr, FALSE);

	} while(0);
	return pNewName;
}

//--------------------------------------------------------------------------------------------------------------//
//	fBNgRs[ʒʒm																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbDirNotify(C_UTP pPathFrom, C_UTP pPathTo, EAJCCFS ntc, UX cbp)
{
	//	O\
	print_log(TEXT("   Folder Create From %s\n") , pPathFrom);
	print_log(TEXT("                 To   %s - "), pPathTo	);
	switch (ntc) {
		case AJCCFS_SUCCESS:	print_log(TEXT("Success"));			break;
		case AJCCFS_FAILURE:	print_log(TEXT("Failure"));			break;
		case AJCCFS_EXIST:		print_log(TEXT("Already exist"));	break;
	}
	print_log(TEXT("\n"));

	//	̃tH_̃t@CRs[
	if (!fOnlyStruct && ntc != AJCCFS_FAILURE) {
		AjcCopyFilesEx(pPathFrom, pPathTo, TEXT("*.*"), TRUE, 0, cbFileNotify, cbFileQuery);
	}
	return TRUE;
}

//--------------------------------------------------------------------------------------------------------------//
//	t@CRs[ہ^̕ύX̖₢킹																	//
//--------------------------------------------------------------------------------------------------------------//
static	UTP CALLBACK cbFileQuery(C_UTP pFileFrom, C_UTP pFileTo, UTP pFileName, UIP pAtt, UX cbp)
{
	UTP		pNewName =pFileName;

	do {
		//	t`FbNi /D IvVj
		if (fChkDate) {
			if (AjcPathIsFile(pFileFrom) && AjcPathIsFile(pFileTo)) {
				UI	tmOld = AjcGetFileTime1970(pFileFrom);
				UI	tmNew = AjcGetFileTime1970(pFileTo	);
				if (tmOld != -1 && tmNew != -1) {
					if (tmOld <= tmNew) {
						pNewName = NULL; break;
					}
				}
			}
		}

		//	A[JCu`FbN( /A /M IvVj
		if (fArc) {
			//	A[JCuȊOȂ΃Rs[Ȃ( /A IvVj
			if (!(*pAtt & FILE_ATTRIBUTE_ARCHIVE)){pNewName = NULL; break;}
		}

		//	Rs[Ώۃt@C`FbNi /FINC: IvVj
		if (AjcSplNumber(hSplFInc) != 0) {
			fFind = FALSE;
			AjcSplEnumStr(hSplFInc, (UX)pNewName, cbSplEnum, FALSE);
		}
		else {
			fFind = TRUE;
		}
		if (!fFind) {pNewName = NULL; break;}

		//	Rs[ΏۊOt@C`FbNi /FEXC: IvVj
		if (AjcSplNumber(hSplFExc) != 0) {
			fFind = FALSE;
			AjcSplEnumStr(hSplFExc, (UX)pNewName, cbSplEnum, FALSE);
		}
		else {
			fFind = FALSE;
		}
		if (fFind) {pNewName = NULL; break;}

		//	̈vɂt@CύXi /FR: IvVj
		AjcAvsEnumNodesEx(hAvsFR, (UX)pNewName, cbAvsEnumMatch, FALSE);

		//	ړɂt@CύXi /FRT: IvVj
		AjcAvsEnumNodesEx(hAvsFRT, (UX)pNewName, cbAvsEnumTop, FALSE);

		//	ɂt@CύXi /FRS: IvVj
		AjcAvsEnumNodesEx(hAvsFRS, (UX)pNewName, cbAvsEnumStr, FALSE);

	} while(0);
	return pNewName;
}

//--------------------------------------------------------------------------------------------------------------//
//	t@CRs[ʒʒm																						//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbFileNotify( C_UTP pFileFrom, C_UTP pFileTo, EAJCCFS ntc, UX cbp)
{
	//	Rs[ARs[t@C̃A[JCu( /M IvVj
	if (fArcRes) {
		UI att = GetFileAttributes(pFileFrom);
		att &= ~FILE_ATTRIBUTE_ARCHIVE;
		SetFileAttributes(pFileFrom, att);
	}

	//	O\
	print_log(TEXT("   File Copy From %s to %s - ") , pFileFrom, pFileTo);
	switch (ntc) {
		case AJCCFS_SUCCESS:	print_log(TEXT("Success"));			break;
		case AJCCFS_FAILURE:	print_log(TEXT("Failure"));			break;
		case AJCCFS_EXIST:		print_log(TEXT("Already exist"));	break;
	}
	print_log(TEXT("\n"));

	return TRUE;
}

//--------------------------------------------------------------------------------------------------------------//
//	ChJ[hɂtH_^t@Cv`FbNirok񋓃R[obNj							//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbSplEnum (C_UTP pWild, UX cbp)
{
	BOOL	rc = TRUE;
	UTP		pName = (UTP)cbp;

	if (fFind = PathMatchSpec(pName, pWild)) {
		rc = FALSE;
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	vɂ閼̕ύXi`ur񋓃R[obNj															//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbAvsEnumMatch (C_UTP pKey, VOP pNodeData, UI len, UI nest, UX cbp)
{
	UTP		pOld  = (UTP)pKey;
	UTP		pNew  = (UTP)pNodeData;
	UTP		pName = (UTP)cbp;

	if (MAjcMbsICmp(pName, pOld) == 0) {
		strcpy(pName, pNew);
	}
	return TRUE;
}

//--------------------------------------------------------------------------------------------------------------//
//	ړɂ閼̕ύXi`ur񋓃R[obNj																//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbAvsEnumTop (C_UTP pKey, VOP pNodeData, UI len, UI nest, UX cbp)
{
	UTP		pOld  = (UTP)pKey;
	UTP		pNew  = (UTP)pNodeData;
	UTP		pName = (UTP)cbp;
	UI		lOld  = MAjcMbsLen(pOld);
	UI		lNew  = MAjcMbsLen(pNew);
	UI		lName = MAjcMbsLen(pName);

	if (lName >= lOld && MAjcMbsNICmp(pName, pOld, lNew) == 0) {
		UI stlOld = (UI)MAjcStrLen(pOld);
		UI stlNew = (UI)MAjcStrLen(pNew);
		AjcRepPartStr(pName, MAX_PATH, 0, stlOld, pNew, stlNew);
	}

	return TRUE;
}

//--------------------------------------------------------------------------------------------------------------//
//	ɂ閼̕ύXi`ur񋓃R[obNj																//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbAvsEnumStr (C_UTP pKey, VOP pNodeData, UI len, UI nest, UX cbp)
{
	UTP		pOld  = (UTP)pKey;
	UTP		pNew  = (UTP)pNodeData;
	UTP		pName = (UTP)cbp;
	UI		lOld  = MAjcMbsLen(pOld);
	UI		lNew  = MAjcMbsLen(pNew);
	UI		lName = MAjcMbsLen(pName);
	UTP		p;

	if ((p = MAjcMbsIStr(pName, pOld)) != NULL) {
		UI	loc = (UI)((UX)p - (UX)pName);
		UI stlOld = (UI)MAjcStrLen(pOld);
		UI stlNew = (UI)MAjcStrLen(pNew);
		AjcRepPartStr(pName, MAX_PATH, loc, stlOld, pNew, stlNew);
	}

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
//	΃pXݒ																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetAbsPath(C_UTP pPath, UTP pBuf)
{
	UT		CurDir[MAX_PATH];

	if (PathIsRelative(pPath)) {
		GetCurrentDirectory(MAX_PATH, CurDir);
		PathCombine(pBuf, CurDir, pPath);
	}
	else {
		PathCombine(pBuf, pPath, NULL);
	}
}

