#pragma warning(disable:4996)
#include	<Windows.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<io.h>
#include	<sys/types.h>
#include	<sys/stat.h>

//	t@C^C
typedef union {
	FILETIME  ft;
	long long v;
} UFT;

//	Ɨ̈
static	BOOL		fErr = FALSE;
static	int			Cnt  = 0;

//	Tu֐
static	void	ShowAllFiles(int argc, char *argv[]);
static	void	cbShowAllFiles(char *path, BOOL fDir, long long cbp);
static	void	ChangeByAbsolute(int argc, char *argv[], long long rel);
static	void	cbChangeByAbsolute(char *path, BOOL fDir, long long ftm);
static	void	ChangeByRelative(int argc, char *argv[], long long rel);
static	void	cbChangeByRelative(char *path, BOOL fDir, long long rel);
static	void	fsearch(int argc, char *argv[], long long cbp, void (*cb)(char *path, BOOL fDir, long long cbp));
static	void	sub_fsearch(char *path, long long cbp, void (*cb)(char *path, BOOL fDir, long long cbp));
static	BOOL	IsDir(char *path);


//------------------------------------------------------------------------------//
//																				//
//	m a i n																		//
//																				//
//------------------------------------------------------------------------------//
int main(int argc, char *argv[])
{
	char		txt[16384];

	//	SfBNg\
	if (argc == 1) {
		printf("\n");
		printf("--- Change the timestamp of the file. ----------------------------------------\n\n");
		printf("  Command format : TMS {FilePath | DirectoryPath} ...\n");
		printf("  <FilePath>     : The file to which time-stamp is changed.\n");
		printf("  <DirectoryPath>: Change the time-stamp of all the files under the directory.\n");
		printf("                   Including subdirectories.\n");
		printf("\n");
	}
	else {
		ShowAllFiles(argc, argv);
	}

	if (!fErr) {
		printf(" Change file time, The input pattern is as follows.\n\n");
		printf("  << Relative time is added >>\n");
		printf("     Days   : '[-]nnn'\n");
		printf("     Hours  : '[-]nnnH'\n");
		printf("     Minute : '[-]nnnM'\n");
		printf("     Second : '[-]nnnS'\n\n");
		printf("  << Absolute time is set   >>\n");
		printf("     Date and time: 'yyyy/mm/dd hh:mm:ss'\n\n");
		printf("  << Not change             >>\n");
		printf("     Enter only 'return' key.\n");

		if (argc >= 2) {
			printf("\n Please input - ");
			gets(txt);
			printf("\n");
			//	Ύ
			if (strstr(txt, "/") || strstr(txt, ":")) {
				SYSTEMTIME	st;
				UFT			uft;
				char		*p;

				memset(&st, 0xFF, sizeof st);
				st.wMilliseconds = 0;
				do {
					//	t
					if (p = strtok(txt , "/")) st.wYear   = atoi(p); else break;
					if (p = strtok(NULL, "/")) st.wMonth  = atoi(p); else break;
					if (p = strtok(NULL, " ")) st.wDay	  = atoi(p); else break;
					//	
					if (p = strtok(NULL, ":")) st.wHour   = atoi(p); else break;
					if (p = strtok(NULL, ":")) st.wMinute = atoi(p); else break;
					if (p = strtok(NULL, " ")) st.wSecond = atoi(p); else break;
				} while(0);
				if (SystemTimeToFileTime(&st, &uft.ft)) {
					ChangeByAbsolute(argc, argv, uft.v);
				}
				else {
					printf("*** Invalid absolute time format or value. ***\n");
					fErr = TRUE;
				}
			}
			//	Ύ
			else {
				long long rel = _atoi64(txt);
				if (rel != 0) {
					if		(strstr(txt, "S") || strstr(txt, "s")) rel *= (10000000LL				 );
					else if (strstr(txt, "M") || strstr(txt, "m")) rel *= (10000000LL * 60LL		 );
					else if (strstr(txt, "H") || strstr(txt, "h")) rel *= (10000000LL * 3600LL		 );
					else										   rel *= (10000000LL * 3600LL * 24LL);
					ChangeByRelative(argc, argv, rel);
				}
			}
		}
	}

	if (fErr || argc == 1) {
		printf("\n--- Hit Enter Key -");
		getchar();
	}

	return 0;
}
//------------------------------------------------------------------------------//
//	St@C\															//
//------------------------------------------------------------------------------//
static	void	ShowAllFiles(int argc, char *argv[])
{
	Cnt = 0;
	fsearch(argc, argv, 0, cbShowAllFiles);
	printf("\n");
}
//------------------------------------------------------------------------------//
static	void	cbShowAllFiles(char *path, BOOL fDir, long long cbp)
{
	if (Cnt == 0) {
		printf("--- Change the timestamp of the following files.\n");
	}

	if (!fDir) {
		printf("%4d - %s\n", ++Cnt, path);
	}
}
//------------------------------------------------------------------------------//
//	΃t@Cݒ														//
//------------------------------------------------------------------------------//
static	void	ChangeByAbsolute(int argc, char *argv[], long long ftm)
{
	fsearch(argc, argv, ftm, cbChangeByAbsolute);
}
//------------------------------------------------------------------------------//
static	void	cbChangeByAbsolute(char *path, BOOL fDir, long long ftm)
{
	HANDLE		hFile;
	UFT			fmk, fac, fup;
	UFT			uft;

	if (!fDir) {
		uft.v = ftm;
		LocalFileTimeToFileTime(&uft.ft, &fmk.ft);
		LocalFileTimeToFileTime(&uft.ft, &fac.ft);
		LocalFileTimeToFileTime(&uft.ft, &fup.ft);
		if ((hFile = CreateFile(path, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			SetFileTime(hFile, &fmk.ft, &fac.ft, &fup.ft);
			CloseHandle(hFile);
		}
		else {
			printf("*** file(%s) open failure ***\n", path);
			fErr = TRUE;
		}
	}
}
//------------------------------------------------------------------------------//
//	΃t@Cݒ														//
//------------------------------------------------------------------------------//
static	void	ChangeByRelative(int argc, char *argv[], long long rel)
{
	fsearch(argc, argv, rel, cbChangeByRelative);
}
//------------------------------------------------------------------------------//
static	void	cbChangeByRelative(char *path, BOOL fDir, long long rel)
{
	HANDLE		hFile;
	UFT			fmk, fac, fup;

	if (!fDir) {
		if ((hFile = CreateFile(path, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			GetFileTime(hFile, &fmk.ft, &fac.ft, &fup.ft);
			fmk.v  += rel;
			fac.v  += rel;
			fup.v  += rel;
			SetFileTime(hFile, &fmk.ft, &fac.ft, &fup.ft);
			CloseHandle(hFile);
		}
		else {
			printf("*** file(%s) open failure ***\n", path);
			fErr = TRUE;
		}
	}
}
//------------------------------------------------------------------------------//
//	t@C																//
//------------------------------------------------------------------------------//
static	void	fsearch(int argc, char *argv[], long long cbp, void (*cb)(char *path, BOOL fDir, long long cbp))
{
	int		i;

	for (i = 1; i < argc; i++) {
		sub_fsearch(argv[i], cbp, cb);
	}
}
//------------------------------------------------------------------------------//
static	void	sub_fsearch(char *path, long long cbp, void (*cb)(char *path, BOOL fDir, long long cbp))
{
	intptr_t			hs;
	struct _finddata_t	fi;
	BOOL				fDir;
	char				inpath[MAX_PATH];
	char				target[MAX_PATH];

	//	fBNg`FbN
	fDir = IsDir(path);

	//	fBNgȂ΁AChJ[ht
	if (fDir) {
		_snprintf(inpath, sizeof inpath, "%s\\*.*", path);
		cb(path, TRUE, cbp);
	}
	else {
		strcpy(inpath, path);
	}
	//	t@C
	if ((hs = _findfirst(inpath, &fi)) != -1) {
		do {
			if (fi.attrib & _A_SUBDIR) {
				if (strcmp(fi.name, ".") != 0 && strcmp(fi.name, "..") != 0) {
					strcpy(target, path);
					strcat(target, "\\");
					strcat(target, fi.name);
					sub_fsearch(target, cbp, cb);
				}
			}
			else {
				strcpy(target, path);
				if (IsDir(path)) {
					strcat(target, "\\");
					strcat(target, fi.name);
				}
				cb(target, FALSE, cbp);
			}
		} while (_findnext(hs, &fi) == 0);
		_findclose(hs);
	}
}
//------------------------------------------------------------------------------//
//	fBNg`FbN														//
//------------------------------------------------------------------------------//
static	BOOL	IsDir(char *path)
{
	BOOL			rc = FALSE;
	struct _stat	st;

	if (_stat(path, &st) == 0) {
		rc = ((st.st_mode & _S_IFDIR) != 0);
	}
	else {
		printf("*** Invalid path spec '%s'.\n", path);
		fErr = TRUE;
	}
	return rc;
}
