#ifndef	AJCFILEDIR_H_
#define	AJCFILEDIR_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcCopyFolderStruct				AjcCopyFolderStructW
	#define	AjcCopyFolderStructEx			AjcCopyFolderStructExW
	#define	AjcCopyFiles					AjcCopyFilesW
	#define	AjcCopyFilesEx					AjcCopyFilesExW
	#define	AjcRemoveFolder					AjcRemoveFolderW
	#define	AjcCleanFolder					AjcCleanFolderW
	#define	AjcPathExists					AjcPathExistsW
	#define	AjcPathIsDirectory				AjcPathIsDirectoryW
	#define	AjcPathIsFile					AjcPathIsFileW
	#define	AjcGetFileSize					AjcGetFileSizeW
	#define	AjcGetFileTime1970				AjcGetFileTime1970W
	#define	AjcFileCompare					AjcFileCompareW
	#define	AjcGetFileTime					AjcGetFileTimeW
	#define	AjcSetFileTime					AjcSetFileTimeW
	#define	AjcSetFileTimeBySysTime			AjcSetFileTimeBySysTimeW
#else
	#define	AjcCopyFolderStruct				AjcCopyFolderStructA
	#define	AjcCopyFolderStructEx			AjcCopyFolderStructExA
	#define	AjcCopyFiles					AjcCopyFilesA
	#define	AjcCopyFilesEx					AjcCopyFilesExA
	#define	AjcRemoveFolder					AjcRemoveFolderA
	#define	AjcCleanFolder					AjcCleanFolderA
	#define	AjcPathExists					AjcPathExistsA
	#define	AjcPathIsDirectory				AjcPathIsDirectoryA
	#define	AjcPathIsFile					AjcPathIsFileA
	#define	AjcGetFileSize					AjcGetFileSizeA
	#define	AjcGetFileTime1970				AjcGetFileTime1970A
	#define	AjcFileCompare					AjcFileCompareA
	#define	AjcGetFileTime					AjcGetFileTimeA
	#define	AjcSetFileTime					AjcSetFileTimeA
	#define	AjcSetFileTimeBySysTime			AjcSetFileTimeBySysTimeA
#endif

//--------------------------------------------------------------------------------------------------------------//
//	AjcCopyFolderStruct()/AjcCopyFiles()̒ʒmR[h															//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCCFS_SUCCESS		= 0	,		//	fBNg쐬 
	AJCCFS_FAILURE			,		//	fBNg쐬 s
	AJCCFS_EXIST			,		//	ɓpX݂
} EAJCCFS, *PEAJCCFS;

//--------------------------------------------------------------------------------------------------------------//
//	t@C^C	i1601NE莞 (UTC)  12:00 AM o߂ 100 imbԊu̐\ 64 rbglj	//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	FILETIME  	ft;
	ULL			v;
} AJCUFT, *PAJCUFT;
typedef const AJCUFT *PCAJCUFT;

//	t@C^CQiʎZj
typedef struct {
	AJCUFT	mk;				//	쐬
	AJCUFT	ac;				//	ANZX
	AJCUFT	up;				//	XV
} AJCFTIMES, *PAJCFTIMES;
typedef const AJCFTIMES *PCAJCFTIMES;

//	t@C^CQiVXe^C`j
typedef struct {
	SYSTEMTIME	mk;			//	쐬
	SYSTEMTIME	ac;			//	ANZX
	SYSTEMTIME	up;			//	XV
} AJCSTIMES, *PAJCSTIMES;
typedef const AJCSTIMES *PCAJCSTIMES;

//	tH_\Rs[̃^CX^vIvV
typedef enum {
	AJCFSC_NONE			= 0		,		//	IvV
	AJCFSC_SAMETIME		= 0x01	,		//	VK쐬tH_̃^CX^vRs[Ɠɂ
	AJCFSC_FORCETIME	= 0x02	,		//	VK쐬tH_ƊtH_̃^CX^vRs[Ɠɂ
} AJCFSC_OPT, *PAJCFSC_OPT;
typedef const AJCFSC_OPT *PCAJCFSC_OPT;

/*--------------------------------------------------------------------------------------------------------------*/
/*	vg^Cv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	BOOL	WINAPI AjcCopyFolderStructA(C_BCP pPathFrom, C_BCP pPathTo, AJCFSC_OPT opt);
AJCEXPORT	BOOL	WINAPI AjcCopyFolderStructW(C_WCP pPathFrom, C_WCP pPathTo, AJCFSC_OPT opt);


AJCEXPORT	BOOL	WINAPI	AjcCopyFolderStructExA(C_BCP pPathFrom, C_BCP pPathTo, AJCFSC_OPT opt, UX cbp, 
													BOOL (CALLBACK *cbNotify)(C_BCP pPathFrom , C_BCP pPathTo, EAJCCFS ntc, UX cbp),
													BCP  (CALLBACK *cbQuery )(C_BCP pPathFront,   BCP pNewDir,				UX cbp));
AJCEXPORT	BOOL	WINAPI	AjcCopyFolderStructExW(C_WCP pPathFrom, C_WCP pPathTo, AJCFSC_OPT opt, UX cbp, 
													BOOL (CALLBACK *cbNotify)(C_WCP pPathFrom , C_WCP pPathTo, EAJCCFS ntc, UX cbp),
													WCP  (CALLBACK *cbQuery )(C_WCP pPathFront,   WCP pNewDir,				UX cbp));


AJCEXPORT	BOOL	WINAPI AjcCopyFilesA(C_BCP pPathFrom, C_BCP pPathTo, C_BCP pWildCard, BOOL fCreateAlways);
AJCEXPORT	BOOL	WINAPI AjcCopyFilesW(C_WCP pPathFrom, C_WCP pPathTo, C_WCP pWildCard, BOOL fCreateAlways);

AJCEXPORT	BOOL	WINAPI AjcCopyFilesExA(C_BCP pPathFrom, C_BCP pPathTo, C_BCP pWildCard, BOOL fCreateAlways, UX cbp,
											BOOL (CALLBACK *cbNotify)(C_BCP pFileFrom, C_BCP pFileTo, EAJCCFS ntc, UX cbp),
											BCP  (CALLBACK *cbQuery )(C_BCP pFileFrom, C_BCP pFileTo, BCP pFileName, UIP pAtt, UX cbp));
AJCEXPORT	BOOL	WINAPI AjcCopyFilesExW(C_WCP pPathFrom, C_WCP pPathTo, C_WCP pWildCard, BOOL fCreateAlways, UX cbp,
											BOOL (CALLBACK *cbNotify)(C_WCP pFileFrom, C_WCP pFileTo, EAJCCFS ntc , UX cbp),
											WCP  (CALLBACK *cbQuery )(C_WCP pFileFrom, C_WCP pFileTo, WCP pFileName, UIP pAtt, UX cbp));

AJCEXPORT	BOOL	WINAPI AjcRemoveFolderA(C_BCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_BCP pPathRemoved, BOOL fDir, UX cbp));
AJCEXPORT	BOOL	WINAPI AjcRemoveFolderW(C_WCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP pPathRemoved, BOOL fDir, UX cbp));

AJCEXPORT	BOOL	WINAPI AjcCleanFolderA(C_BCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_BCP pPathRemoved, BOOL fDir, UX cbp));
AJCEXPORT	BOOL	WINAPI AjcCleanFolderW(C_WCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP pPathRemoved, BOOL fDir, UX cbp));

AJCEXPORT	BOOL	WINAPI	AjcPathExistsA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI	AjcPathExistsW(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI	AjcPathIsDirectoryA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI	AjcPathIsDirectoryW(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI	AjcPathIsFileA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI	AjcPathIsFileW(C_WCP pPath);

AJCEXPORT	ULL		WINAPI	AjcGetFileSizeA(C_BCP pPath);
AJCEXPORT	ULL		WINAPI	AjcGetFileSizeW(C_WCP pPath);

AJCEXPORT	UI		WINAPI	AjcGetFileTime1970A(C_BCP pPath);
AJCEXPORT	UI		WINAPI	AjcGetFileTime1970W(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI	AjcFileCompareA(C_BCP pFile1, C_BCP pFile2);
AJCEXPORT	BOOL	WINAPI	AjcFileCompareW(C_WCP pFile1, C_WCP pFile2);

AJCEXPORT	BOOL	WINAPI	AjcGetFileTimeA(C_BCP pPath, PAJCFTIMES pFTimes, PAJCSTIMES pSTimes, BOOL fLocalTime);
AJCEXPORT	BOOL	WINAPI	AjcGetFileTimeW(C_WCP pPath, PAJCFTIMES pFTimes, PAJCSTIMES pSTimes, BOOL fLocalTime);

AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeA(C_BCP pPath, PCAJCFTIMES pFTimes, BOOL fLocalTime);
AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeW(C_WCP pPath, PCAJCFTIMES pFTimes, BOOL fLocalTime);

AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeBySysTimeA(C_BCP pPath, LPSYSTEMTIME pSTimes, BOOL fLocalTime);
AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeBySysTimeW(C_WCP pPath, LPSYSTEMTIME pSTimes, BOOL fLocalTime);

/****************************************************************************************************************/
#endif
