#ifndef	AJCPOWMG_H_
#define	AJCPOWMG_H_
/****************************************************************************************************************/

/*--------------------------------------------------------------------------------------------------------------*/
/*	jR[h																									*/
/*--------------------------------------------------------------------------------------------------------------*/
#define		AJCPMG_SUNDAY		0x01		/*				*/
#define		AJCPMG_MONDAY		0x02		/*				*/
#define		AJCPMG_TUESDAY		0x04		/*				*/
#define		AJCPMG_WEDNESDAY	0x08		/*				*/
#define		AJCPMG_THURSDAY		0x10		/*				*/
#define		AJCPMG_FRIDAY		0x20		/*				*/
#define		AJCPMG_SATURDAY		0x40		/*	y			*/

#define		AJCPMG_ALLDAYS		0x7F		/*	ׂĂ̓	*/
#define		AJCPMG_WEEKDAY		0x3E		/*	`		*/
#define		AJCPMG_WEEKEND		0x41		/*	y		*/

/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcPmgSetSchedTime		AjcPmgSetSchedTimeW
	#define	AjcPmgSetSchedInterval	AjcPmgSetSchedIntervalW
	#define	AjcPmgSetSchedWeekly	AjcPmgSetSchedWeeklyW
#else
	#define	AjcPmgSetSchedTime		AjcPmgSetSchedTimeA
	#define	AjcPmgSetSchedInterval	AjcPmgSetSchedIntervalA
	#define	AjcPmgSetSchedWeekly	AjcPmgSetSchedWeeklyA
#endif

/*--------------------------------------------------------------------------------------------------------------*/
/*	vg^Cv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT BOOL	WINAPI	AjcPmgClear					(VO);
AJCEXPORT BOOL	WINAPI	AjcPmgDisplayOn				(BOOL fEnable);

AJCEXPORT BOOL	WINAPI	AjcPmgSetSchedTimeA	(int year, int month, int day, int hour, int minute, BOOL fResume, int latency, C_BCP pExe, C_BCP pArg, int ExeTime);
AJCEXPORT BOOL	WINAPI	AjcPmgSetSchedTimeW	(int year, int month, int day, int hour, int minute, BOOL fResume, int latency, C_WCP pExe, C_WCP pArg, int ExeTime);

AJCEXPORT BOOL	WINAPI	AjcPmgSetSchedIntervalA	(int minute                                    , BOOL fResume, int latency, C_BCP pExe, C_BCP pArg, int ExeTime);
AJCEXPORT BOOL	WINAPI	AjcPmgSetSchedIntervalW	(int minute                                    , BOOL fResume, int latency, C_WCP pExe, C_WCP pArg, int ExeTime);

AJCEXPORT BOOL	WINAPI	AjcPmgSetSchedWeeklyA	(int DayOfWeek, int hour, int minute           , BOOL fResume, int latency, C_BCP pExe, C_BCP pArg, int ExeTime);
AJCEXPORT BOOL	WINAPI	AjcPmgSetSchedWeeklyW	(int DayOfWeek, int hour, int minute           , BOOL fResume, int latency, C_WCP pExe, C_WCP pArg, int ExeTime);

AJCEXPORT BOOL	WINAPI	AjcPmgShowWindow	(VO);
AJCEXPORT BOOL	WINAPI	AjcPmgHideWindow	(VO);
AJCEXPORT BOOL	WINAPI	AjcPmgExitProgram	(VO);

/****************************************************************************************************************/
#endif
