#ifndef	AJCSERIALCOMM_H_
#define	AJCSERIALCOMM_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcScmCreate			AjcScmCreateW
	#define	AjcScmLoadParam			AjcScmLoadParamW
	#define	AjcScmSaveParam			AjcScmSaveParamW
	#define	AjcScmSendText			AjcScmSendTextW
	#define	AjcScmGetPortPathName	AjcScmGetPortPathNameW
	#define	AjcScmGetPortName		AjcScmGetPortNameW
	#define	AjcScmUseSlot			AjcScmUseSlotW
#else
	#define	AjcScmCreate			AjcScmCreateA
	#define	AjcScmLoadParam			AjcScmLoadParamA
	#define	AjcScmSaveParam			AjcScmSaveParamA
	#define	AjcScmSendText			AjcScmSendTextA
	#define	AjcScmGetPortPathName	AjcScmGetPortPathNameA
	#define	AjcScmGetPortName		AjcScmGetPortNameA
	#define	AjcScmUseSlot			AjcScmUseSlotA
#endif
//--------------------------------------------------------------------------------------------------------------//
//	CxgR[h																								//
//--------------------------------------------------------------------------------------------------------------//
						//	HIWORD(wParam)		e
#define	AJCSCM_EV_PORTSTATE	0x8000			//	|[gԒʒm
#define	AJCSCM_EV_RXCHUNK	0x4000			//	`Nf[^Mʒm
#define	AJCSCM_EV_RXTEXT	0x2000			//	eLXgMʒm
#define	AJCSCM_EV_RXESC		0x1000			//	drbR[hMʒm
#define	AJCSCM_EV_RXCTRL	0x0800			//	R[hMʒm
#define	AJCSCM_EV_RXPKT		0x0400			//	pPbgf[^Mʒm
#define	AJCSCM_EV_TXEMPTY	0x0200			//	M
#define	AJCSCM_EV_RXNOPKT	0x0100			//	pPbgOoCgf[^

#define	AJCSCM_EV_ERR		0x0080			//	G[ʒm
#define	AJCSCM_EV_BREAK		0x0040			//	BREAKoʒm
#define	AJCSCM_EV_RING		0x0020			//	RINGωʒm
#define	AJCSCM_EV_RLSD		0x0010			//	RLSDωʒm
#define	AJCSCM_EV_DSR		0x0008			//	DSRωʒm
#define	AJCSCM_EV_CTS		0x0004			//	CTSωʒm
#define	AJCSCM_EV_RXFLAG	0x0002			//	tOoCgMʒm
#define	AJCSCM_EV_RXCHAR	0x0001			//	PoCgMʒm

#define	AJCSCM_EV_SSEP				(AJCSCM_EV_RXTEXT | AJCSCM_EV_RXESC | AJCSCM_EV_RXCTRL | AJCSCM_EV_RXPKT)
#define	AJCSCM_EV_DEFAULT_EVT		(AJCSCM_EV_SSEP | AJCSCM_EV_DSR | AJCSCM_EV_CTS)
#define	AJCSCM_EV_DEFAULT_POST		(AJCSCM_EV_PORTSTATE | AJCSCM_EV_DEFAULT_EVT)


//--------------------------------------------------------------------------------------------------------------//
//	|[g(AJCSCM_EV_PORTSTATẼp^)																	//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCSCM_CLOSED		0			//	N[Y
#define		AJCSCM_OPENED		1			//	I[v
#define		AJCSCM_OPENFAIL		2			//	I[vs
#define		AJCSCM_PORTNO		3			//	|[gԍω

//--------------------------------------------------------------------------------------------------------------//
//	M																									//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCSCM_CTS		MS_CTS_ON
#define		AJCSCM_DSR		MS_DSR_ON
#define		AJCSCM_RING		MS_RING_ON
#define		AJCSCM_RLSD		MS_RLSD_ON

//--------------------------------------------------------------------------------------------------------------//
//	ʐMG[R[h																							//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCSCM_CE_BREAK		CE_BREAK
#define		AJCSCM_CE_DNS		CE_DNS
#define		AJCSCM_CE_FRAME		CE_FRAME
#define		AJCSCM_CE_IOE		CE_IOE
#define		AJCSCM_CE_MODE		CE_MODE
#define		AJCSCM_CE_OOP		CE_OOP
#define		AJCSCM_CE_OVERRUN	CE_OVERRUN
#define		AJCSCM_CE_PTO		CE_PTO
#define		AJCSCM_CE_RXOVER	CE_RXOVER
#define		AJCSCM_CE_RXPARITY	CE_RXPARITY
#define		AJCSCM_CE_TXFULL	CE_TXFULL

//--------------------------------------------------------------------------------------------------------------//
//	Cxgnh																							//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	struct {HANDLE Comm, Recv, TxEnd, Cmd, Exit, TmSlt;} s;
	HANDLE	arr[5];
} AJCSCM_HEVENT;

//--------------------------------------------------------------------------------------------------------------//
//	`NEf[^E[h																					//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCSCM_CM_BIN	=	0	,				//	oCi`N
	AJCSCM_CM_TEXT	=	1	,				//	eLXg`N
} AJCSCM_CHUNKMODE;

//--------------------------------------------------------------------------------------------------------------//
//	MeLXgER[h																						//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCSCM_RXC_SJIS	=	1	,				//	Vtgihr
	AJCSCM_RXC_EUC	=	2	,				//	dtb@@@
	AJCSCM_RXC_UTF8	=	3	,				//	tse|W@
	AJCSCM_RXC_AUTO	=	9	,				//	ʁ@@
} AJCSCM_RXTEXTCODE;

//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
typedef  struct {
	UI					PortNo;				//	bnl|[gԍiP`QTTj
	DCB					CommDcb;			//	cba
	COMMTIMEOUTS		CommTmo;			//	^CAEg

	HANDLE				hPort;				//	bnl|[g^[Xbg|[gnh
	AJCSCM_HEVENT		hEvt;				//	Cxgnh

	BOOL				fUnicode;			//	UNICODEtO
	BOOL				fTextChunk;			//	eLXg`NtO
	AJCSCM_RXTEXTCODE	RxTxtCode;			//	MeLXgR[h
	UI					EvtMask;			//	Cxg}XN


	HWND				hWndNtc;			//	[U`oւ̃CxgʒmpEChnh
	UI					MsgNtc;				//	[U`oւ̃CxgʒmpEChbZ[W
	HAJCFMBX			hFMbxNtc;			//	[U`oւ̃Cxgʒmp[{bNXnh

	HAJCRNG				hRngTxDat;			//	Mf[^i[obt@

	HAJCRNG				hRngCmd;			//	TuXbhւ̃R}hobt@
	UI					ThreadState;		//	TuXbh
	CRITICAL_SECTION	CsCommApi;			//	NeBJZNVIuWFNg

	UI					mskGray;			//	_CAOO[ڂ̃}XN

	UB					BufCmd	[1024];		//	TuXbhւ̃R}hpX^eBbNobt@
	UB					BufTxDat[1024];		//	Mf[^i[obt@p	 V
	UB					BufChunk[1024];		//	`Nf[^i[p		 V
	BC					BufText [1024];		//	eLXgf[^i[p		 V

	VOP				pTwk;					//	[N|C^

	//----- I[vԒʒm -------------------------------------------//
	HWND			hWndNtcPortState;
	UI				MsgNtcPortState;

	//----- |[g̍쐬[N -------------------------------------------//
	union {
		BC		BStr[MAX_COMPUTERNAME_LENGTH + 128];
		UW		WStr[MAX_COMPUTERNAME_LENGTH + 128];
	} PortName;

	//----- [Xbg ---------------------------------------------//
	BOOL	fUseSlot;										//	[XbggptO
	HANDLE	hSlot;											//	[Xbgnh

	UI		TrdTmSltState;									//	XbgMĎ^C}Xbh

	BC		MyHostName [MAX_COMPUTERNAME_LENGTH + 1];		//	Rs[^
	BC		MySlotName [64];								//	[Xbg
	BC		MySlotPath [MAX_COMPUTERNAME_LENGTH + 128];		//	[XbgpX

	BC		RmtHostName[MAX_COMPUTERNAME_LENGTH + 1];		//	Rs[^
	BC		RmtSlotName[64];								//	胁[Xbg
	BC		RmtSlotPath[MAX_COMPUTERNAME_LENGTH + 128];		//	胁[XbgpX

	BC		SltPrfSect[64];									//	XbgL^vt@CZNV

	//----- Mx ---------------------------------------------------//
	BOOL	fTxDelay;										//	MxtO
	UI		TxDelayBPS;										//	Mx[Bytes / sec]
	UI		TxDelayResetInterval;							//	MxZbgC^o[ms]
	ULL		TxDelayBytesCount;								//	MxpoCgJE^
	ULL		TxDelayTickCount;								//	MxpEoߎ[us]

	BOOL	fAbleToUseMicroSec;								//	ʂPʂ̎Ԃv\̃tO
	HAJCMESTIME	hMesTime;									//	ԌvIuWFNgnh

	//----- MSILT|[gp_~[EChnh ---------------------------//
	HWND	hWndForMsil;

} AJCSCM, *HAJCSCM;


//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCM		WINAPI	AjcScmCreateA(VO);
AJCEXPORT	HAJCSCM		WINAPI	AjcScmCreateW(VO);

AJCEXPORT	BOOL		WINAPI	AjcScmSetMode		(HAJCSCM hScm, HWND hWndNtc, UI WndMsgNtc, BOOL fTextChunk);

AJCEXPORT	VO			WINAPI	AjcScmDelete		(HAJCSCM hScm);

AJCEXPORT	BOOL		WINAPI	AjcScmLoadParamA	(HAJCSCM hScm, C_BCP pProfileSect);
AJCEXPORT	BOOL		WINAPI	AjcScmLoadParamW	(HAJCSCM hScm, C_WCP pProfileSect);

AJCEXPORT	BOOL		WINAPI	AjcScmSaveParamA	(HAJCSCM hScm, C_BCP pProfileSect);
AJCEXPORT	BOOL		WINAPI	AjcScmSaveParamW	(HAJCSCM hScm, C_WCP pProfileSect);


AJCEXPORT	BOOL		WINAPI	AjcScmOpen			(HAJCSCM hScm, UI Port, UI Rate, UI DataBits, UI Parity, UI StopBit);
AJCEXPORT	BOOL		WINAPI	AjcScmOpenDefault	(HAJCSCM hScm);
AJCEXPORT	BOOL		WINAPI	AjcScmOpenEx		(HAJCSCM hScm, UI Port, LPDCB pDcb, LPCOMMTIMEOUTS pTmo);
AJCEXPORT	BOOL 		WINAPI	AjcScmClose			(HAJCSCM hScm);
AJCEXPORT	UI			WINAPI	AjcScmIsOpened		(HAJCSCM hScm);

AJCEXPORT	BOOL  		WINAPI	AjcScmSendTextA		(HAJCSCM hScm, C_BCP pTxt, UI lTxt);
AJCEXPORT	BOOL  		WINAPI	AjcScmSendTextW		(HAJCSCM hScm, C_WCP pTxt, UI lTxt);

AJCEXPORT	BOOL  		WINAPI	AjcScmSendBinData	(HAJCSCM hScm, C_VOP pDat, UI lDat);
AJCEXPORT	BOOL  		WINAPI	AjcScmSendPacket	(HAJCSCM hScm, C_VOP pPkt, UI lPkt);
AJCEXPORT	BOOL  		WINAPI	AjcScmSendBreak		(HAJCSCM hScm, BOOL fBreak);
AJCEXPORT	BOOL		WINAPI	AjcScmPause			(HAJCSCM hScm, BOOL fPause);
AJCEXPORT	BOOL		WINAPI	AjcScmGetPauseState	(HAJCSCM hScm);

AJCEXPORT	BOOL		WINAPI	AjcScmSetEvtMask	(HAJCSCM hScm, UI Mask);
AJCEXPORT	UI			WINAPI	AjcScmGetEvtMask	(HAJCSCM hScm);

AJCEXPORT	BOOL  		WINAPI	AjcScmSetDTR		(HAJCSCM hScm, BOOL fActive);
AJCEXPORT	BOOL  		WINAPI	AjcScmSetRTS		(HAJCSCM hScm, BOOL fActive);
AJCEXPORT	UI			WINAPI	AjcScmGetSigState	(HAJCSCM hScm);

AJCEXPORT	BOOL  		WINAPI	AjcScmPurgeRecvData	(HAJCSCM hScm);
AJCEXPORT	BOOL  		WINAPI	AjcScmPurgeSendData	(HAJCSCM hScm);
AJCEXPORT	BOOL  		WINAPI	AjcScmPurgeAllData	(HAJCSCM hScm);

AJCEXPORT	BOOL  		WINAPI	AjcScmSetParam		(HAJCSCM hScm, const DCB *pDcb, const COMMTIMEOUTS *pTmo);
AJCEXPORT	UI			WINAPI	AjcScmGetParam		(HAJCSCM hScm, LPDCB pDcb, LPCOMMTIMEOUTS pTmo);

AJCEXPORT	BOOL		WINAPI	AjcScmWaitEvent 	(HAJCSCM hScm, WPARAM *pwParam, LPARAM *plParam, UI msTime);
AJCEXPORT	VO			WINAPI	AjcScmGetEventData	(HAJCSCM hScm, LPARAM lParam, VOP *ppDat, UIP plDat, UIP pParam);
AJCEXPORT	VO			WINAPI	AjcScmRelEventData	(HAJCSCM hScm, LPARAM lParam);

AJCEXPORT	BOOL		WINAPI	AjcScmSetPktCtrlCode(HAJCSCM hScm, UI stx, UI etx, UI dle);
AJCEXPORT	BOOL		WINAPI	AjcScmSetPktTimeout (HAJCSCM hScm, UI msTime);

AJCEXPORT	BOOL		WINAPI	AjcScmGetPktCtrlCode(HAJCSCM hScm, UIP pStx, UIP pEtx, UIP pDle);
AJCEXPORT	BOOL		WINAPI	AjcScmGetPktTimeout (HAJCSCM hScm, UIP pMsTime);

AJCEXPORT	BOOL		WINAPI	AjcScmDlgParamEasy	(HAJCSCM hScm, HWND hWndOwner);
AJCEXPORT	BOOL		WINAPI	AjcScmDlgParamDetail(HAJCSCM hScm, HWND hWndOwner);
AJCEXPORT	VO			WINAPI	AjcScmSetDialogGrayMask(HAJCSCM hScm, UI mskGray);

AJCEXPORT	VO			WINAPI	AjcScmGetDefaultParam(LPDCB pDcb, LPCOMMTIMEOUTS pTmo);

AJCEXPORT	UI			WINAPI	AjcScmDlgSetParamEasy(HWND hWnd, UIP pPort, LPDCB pDCB, UI mskGray, BOOL *pfToDetail);
AJCEXPORT	UI			WINAPI	AjcScmDlgSetParamDetail(HWND hWnd, UIP pPort, LPDCB pDCB,
											 LPCOMMTIMEOUTS pTMO, UI SysRxBufSize, UI mskGray);

AJCEXPORT	HAJCSSEP	WINAPI	AjcScmGetSsepHandle(HAJCSCM hScm);
AJCEXPORT	UI			WINAPI	AjcScmEnumSerialPorts(UBP pMap, UI lMap, UI CurrentPort);

AJCEXPORT	VO			WINAPI	AjcScmSetNtcPortState(HAJCSCM hScm, HWND hWndNtc, UI MsgNtc);

AJCEXPORT	BCP			WINAPI	AjcScmGetPortPathNameA(HAJCSCM hScm);
AJCEXPORT	WCP			WINAPI	AjcScmGetPortPathNameW(HAJCSCM hScm);

AJCEXPORT	BCP			WINAPI	AjcScmGetPortNameA(HAJCSCM hScm);
AJCEXPORT	WCP			WINAPI	AjcScmGetPortNameW(HAJCSCM hScm);

AJCEXPORT	BOOL		WINAPI	AjcScmSetRxTextCode(HAJCSCM hScm, AJCSCM_RXTEXTCODE code);

AJCEXPORT	VO			WINAPI	AjcScmSetChunkMode	(HAJCSCM hScm, BOOL fTextChunk);
AJCEXPORT	BOOL		WINAPI	AjcScmGetChunkMode	(HAJCSCM hScm);

//----- [Xbg -------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScmUseSlotA(HAJCSCM hScm, C_BCP pMySlotName, C_BCP pRemoteHostName, C_BCP pRemoteSlotName, C_BCP pProfileSect);
AJCEXPORT	BOOL		WINAPI	AjcScmUseSlotW(HAJCSCM hScm, C_WCP pMySlotName, C_WCP pRemoteHostName, C_WCP pRemoteSlotName, C_WCP pProfileSect);

AJCEXPORT	BOOL		WINAPI	AjcScmCanSlot	(HAJCSCM hScm);
AJCEXPORT	BOOL		WINAPI	AjcScmIsSlotMode(HAJCSCM hScm);

AJCEXPORT	VO			WINAPI	AjcScmSetTxSpeedLimit(HAJCSCM pW, BOOL flag, UI bps);
AJCEXPORT	BOOL		WINAPI	AjcScmGetTxSpeedLimit(HAJCSCM pW, UIP pBps);


//==============================================================================================================//
//	_CAO{bNX̃O[ځiScmDlgSetParam... mskGray j										//
//==============================================================================================================//
#define		AJCSCMGRY_Port							0x80000000
#define		AJCSCMGRY_BaudRate						0x40000000
#define		AJCSCMGRY_ByteSize						0x20000000
#define		AJCSCMGRY_StopBits						0x10000000

#define		AJCSCMGRY_fParity						0x08000000
#define		AJCSCMGRY_Parity						0x04000000
#define		AJCSCMGRY_Paritys						(AJCSCMGRY_fParity |		\
													 AJCSCMGRY_Parity)

#define		AJCSCMGRY_fOutX							0x02000000
#define		AJCSCMGRY_fOutxCtsFlow					0x01000000
#define		AJCSCMGRY_fOutxDsrFlow					0x00800000
#define		AJCSCMGRY_TxFlowControl					(AJCSCMGRY_fOutX		|	\
													 AJCSCMGRY_fOutxCtsFlow |	\
													 AJCSCMGRY_fOutxDsrFlow)

#define		AJCSCMGRY_fInX							0x00400000
#define		AJCSCMGRY_XoffLim						0x00200000
#define		AJCSCMGRY_XonLim						0x00100000
#define		AJCSCMGRY_fTXContinueOnXoff				0x00080000
#define		AJCSCMGRY_RxFlowControl					(AJCSCMGRY_fInX		|			\
													 AJCSCMGRY_XoffLim	|			\
													 AJCSCMGRY_XonLim	|			\
													 AJCSCMGRY_fTXContinueOnXoff)

#define		AJCSCMGRY_DtrControl					0x00040000
#define		AJCSCMGRY_RtsControl					0x00020000

#define		AJCSCMGRY_fBinary						0x00010000
#define		AJCSCMGRY_fDsrSensitivity				0x00008000
#define		AJCSCMGRY_fErrorChar					0x00004000
#define		AJCSCMGRY_fNull							0x00002000
#define		AJCSCMGRY_fAbortOnError					0x00001000
#define		AJCSCMGRY_Flags							(AJCSCMGRY_fBinary		   |	\
													 AJCSCMGRY_fDsrSensitivity |	\
													 AJCSCMGRY_fErrorChar	   |	\
													 AJCSCMGRY_fNull		   |	\
													 AJCSCMGRY_fAbortOnError)

#define		AJCSCMGRY_XonChar						0x00000800
#define		AJCSCMGRY_XoffChar						0x00000400
#define		AJCSCMGRY_ErrorChar						0x00000200
#define		AJCSCMGRY_EofChar						0x00000100
#define		AJCSCMGRY_EvtChar						0x00000080
#define		AJCSCMGRY_Characters					(AJCSCMGRY_XonChar	 |	\
													 AJCSCMGRY_XoffChar	 |	\
													 AJCSCMGRY_ErrorChar |	\
													 AJCSCMGRY_EofChar	 |	\
													 AJCSCMGRY_EvtChar)

#define		AJCSCMGRY_ReadIntervalTimeout			0x00000040
#define		AJCSCMGRY_ReadTotalTimeoutMultiplier	0x00000020
#define		AJCSCMGRY_ReadTotalTimeoutConstant		0x00000010
#define		AJCSCMGRY_WriteTotalTimeoutMultiplier	0x00000008
#define		AJCSCMGRY_WriteTotalTimeoutConstant		0x00000004
#define		AJCSCMGRY_Timeouts						(AJCSCMGRY_ReadIntervalTimeout		   |	\
													 AJCSCMGRY_ReadTotalTimeoutMultiplier  |	\
													 AJCSCMGRY_ReadTotalTimeoutConstant	   |	\
													 AJCSCMGRY_WriteTotalTimeoutMultiplier |	\
													 AJCSCMGRY_WriteTotalTimeoutConstant)

#define		AJCSCMGRY_SetDetail						0x00000002

//==============================================================================================================//
//	_CAO{bNXɂύXꂽ(ScmDlgSetParamEasy/Detail̖߂lj									//
//==============================================================================================================//
#define	AJCSCMDGR_OKBUTTON		0x00000080		//	nj{^ɂI
#define	AJCSCMDGR_PORTCHANGED	0x00000040		//	|[gύX
#define	AJCSCMDGR_DCBCHANGED	0x00000020		//	cbaύX
#define	AJCSCMDGR_TMOCHANGED	0x00000010		//	^C}ύX


#ifdef	AJCMSIL
//##############################################################################################################//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//----- Rg[ECh -------------------------------------------------------------------------------//
AJCEXPORT HAJCSCM WINAPI AjcScmCreateForMSIL(	VO (CALLBACK *cbPortState )(int state),
												VO (CALLBACK *cbRxChunkTxt)(C_WCP text),
												VO (CALLBACK *cbRxChunkBin)(C_VOP pData, int lData),
												VO (CALLBACK *cbRxText	  )(C_WCP text),
												VO (CALLBACK *cbRxEsc	  )(C_WCP esc),
												VO (CALLBACK *cbRxCtrl	  )(int   ctrl),
												VO (CALLBACK *cbRxPacket  )(C_VOP pData, int lData),
												VO (CALLBACK *cbTxEmpty   )(VO),
												VO (CALLBACK *cbRxNoPkt   )(int   data),
												VO (CALLBACK *cbError	  )(int err),
												VO (CALLBACK *cbNtcBreak  )(VO),
												VO (CALLBACK *cbNtcRING   )(BOOL cts, BOOL dsr, BOOL rlsd, BOOL ring),
												VO (CALLBACK *cbNtcRLSD   )(BOOL cts, BOOL dsr, BOOL rlsd, BOOL ring),
												VO (CALLBACK *cbNtcDSR	  )(BOOL cts, BOOL dsr, BOOL rlsd, BOOL ring),
												VO (CALLBACK *cbNtcCTS	  )(BOOL cts, BOOL dsr, BOOL rlsd, BOOL ring),
												VO (CALLBACK *cbRxFlag	  )(VO),
												VO (CALLBACK *cbRxChar	  )(VO));
//----- [hݒ ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL WINAPI AjcScmSetModeForMSIL(HAJCSCM hScm, BOOL fEventMode, BOOL fTextChunk);
//----- |[gpX擾 ---------------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScmGetPortPathNameForMSIL(HAJCSCM hScm, WCP pBuf, int lBuf);
//----- I -----------------------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScmDeleteForMSIL(HAJCSCM hScm);

//##############################################################################################################//
#endif	//	AJCMSIL


/****************************************************************************************************************/
#endif
