#pragma warning(disable:4996)
#include	<AjrCst32.h>
#include	<stdio.h>

//--------------------------------------------------------------------------------------------------------------//
//	t@C^C																								//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	FILETIME  ft;
	long long v;
} UFT;
//--------------------------------------------------------------------------------------------------------------//
//	s^Cv																									//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	TYPE_UNKOWN		= 0,		//	s
	TYPE_CRLF		= 1,		//	CF, LF	(Windows)
	TYPE_LF			= 2,		//	LF		(UNIX / LINUX / MAC)
	TYPE_CR			= 3,		//	CR		(MAC(OS9ȑO))
} LFTYPE;

static	LFTYPE	Lft_Inp = TYPE_UNKOWN;
static	LFTYPE	Lft_Out = TYPE_UNKOWN;

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	int		nTab  = 4;					//	^uXebv
static	BOOL	fErr  = FALSE;				//	G[tO

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	void	ConvertLineFeed	(C_BCP pInpPath);
static	LFTYPE	ChkInpLfType	(C_BCP pPath);

//--------------------------------------------------------------------------------------------------------------//
//	m a i n																										//
//--------------------------------------------------------------------------------------------------------------//
int main(int argc, char *argv[])
{
	int		i;

	//	vt@CWXg
	AjcSetProfileIsRegistory(TRUE);
	//	ftHg^uXebvǂݏo
	nTab = AjcGetProfileUInt("Param", "nTab", 4);

	//	̏ꍇ͐\
	if (argc == 1) {
		printf("\n");
		printf("--- Convert line feed (CR+LF, LF or CR) -----------------\n\n");
		printf("     CF+LF(Windows)     -> LF(UNIX/LINUX/MAC)\n");
		printf("     LF(UNIX/LINUX/MAC) -> CF+LF(Windows)\n");
		printf("     CR(MAC before OS9) -> CR+LF(Windows) or LF(UNIX/LINUX/MAC)\n");
		printf("                           Answr selection in prompt message.\n");
		printf("  Command format : CnvLF  <TextFile1> [TextFile2] ...\n\n");
		printf("\n--- Hit ENTER key ---");
		getchar();
	}
	//	L̏ꍇ́Akeϊ
	else if (argc >= 2) {
		for (i = 1; i < argc; i++) {
			//	t@C\
			printf("%3d : %s  ", i, argv[i]);
			//	̓t@C̉s^Cv擾
			Lft_Inp = ChkInpLfType(argv[i]);
			//	o̓t@C̉s^Cvݒ
			Lft_Out = TYPE_UNKOWN;
			switch (Lft_Inp) {
				case TYPE_CRLF:	Lft_Out = TYPE_LF;		printf("CR+LF -> CR)\n"); break;
				case TYPE_LF:	Lft_Out = TYPE_CRLF;	printf("CR -> CR+LF)\n"); break;
				case TYPE_CR:
				{	BC	c;
					printf("\n       LF=CR(Before MAC OS9) -> 1.CR+LF(Windows), 2:LF(Linux..)");
					c = getchar(); printf("%c\n", c);
					if		(c == '1') Lft_Out = TYPE_CRLF;
					else if (c == '2') Lft_Out = TYPE_LF;
					break;
				}
				default:
					printf("** Unknown line feed type.", argv[i]);
					fErr = TRUE;
			}
			//	o̓t@C̉s^CvݒςȂ΁AsR[hύX
			if (Lft_Out != TYPE_UNKOWN) {
				ConvertLineFeed(argv[i]);
			}
		}
	}

	//	G[́Aꎞ~
	if (fErr) {
		printf("\n--- Hit enter key ---");
		getchar();
	}

	return 0;
}

//--------------------------------------------------------------------------------------------------------------//
//	keϊ																									//
//--------------------------------------------------------------------------------------------------------------//
void	ConvertLineFeed(C_BCP pInpPath)
{
	HANDLE		hInp = NULL;
	HANDLE		hOut = NULL;
	UFT			fmk, fac, fup;
	UI			att, bytes;
	BC			OutPath[MAX_PATH] = {0};
	BC			rxc, nxc;

	//	o̓e|t@Cݒ
	GetTempPath(MAX_PATH, OutPath);
	strcat(OutPath, "enTAB.txt");
	//	̓t@C̑擾
	att = GetFileAttributes(pInpPath);
	//	̓eLXgt@CI[v
	if ((hInp = CreateFile(pInpPath, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
		//	̓t@C̃^CX^v擾
		GetFileTime(hInp, &fmk.ft, &fac.ft, &fup.ft);
		//	o̓e|t@C
		if ((hOut = CreateFile(OutPath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			while (ReadFile(hInp, &rxc, 1, &bytes, NULL) && bytes == 1) {
				//	 CR+LF -> LF
				if		(Lft_Inp = TYPE_CRLF) {
					if (rxc == '\r') {
						if (ReadFile(hInp, &nxc, 1, &bytes, NULL) && bytes == 1) {
							if (nxc == '\n') {
								WriteFile(hOut, "\n", 1, &bytes, NULL);
							}
							else {
								WriteFile(hOut, "\r", 1, &bytes, NULL);  // CȐꍇ͂̂܂܏o
							}
						}
						else {
							break;	// EOF
						}
					}
					else {
						WriteFile(hOut, &rxc, 1, &bytes, NULL);
					}
				}
				//	 LF -> CR+LF
				else if (Lft_Inp = TYPE_LF) {
					if (rxc == '\n') {
						WriteFile(hOut, "\r", 1, &bytes, NULL);
						WriteFile(hOut, "\n", 1, &bytes, NULL);
					}
					else {
						WriteFile(hOut, &rxc, 1, &bytes, NULL);
					}
				}
				//	 CR -> CR+LF or LF
				else if (Lft_Inp = TYPE_CR) {
					if (rxc == '\r') {
						if		(Lft_Out == TYPE_CRLF) {
							WriteFile(hOut, "\r", 1, &bytes, NULL);
							WriteFile(hOut, "\n", 1, &bytes, NULL);
						}
						else if (Lft_Out == TYPE_LF  ) {
							WriteFile(hOut, "\n", 1, &bytes, NULL);
						}
					}
					else {
						WriteFile(hOut, &rxc, 1, &bytes, NULL);
					}
				}
			}
			//	̓eLXgt@CN[Y
			CloseHandle(hInp);
			//	o̓e|t@C̃^CX^vݒ
			SetFileTime(AjcFGetFileHandle(hOut), &fmk.ft, &fac.ft, &fup.ft);
			//	o̓e|t@C N[Y
			CloseHandle(hOut);
			//	Rs[eLXgt@C̑uʏt@Cvɐݒ
			SetFileAttributes(pInpPath, FILE_ATTRIBUTE_NORMAL);
			//	o̓e|t@CeLXgt@C֏㏑Rs[
			if (CopyFile(OutPath, pInpPath, FALSE) != 0) {
				//	eLXgt@C̑񕜐ݒ
				SetFileAttributes(pInpPath, att);
			}
			//	o̓e|t@C폜
			DeleteFile(OutPath);
		}
		else {
			printf("Temporary file creation failure.(%s)\n", pInpPath);
			fErr = TRUE;
		}
	}
	else {
		printf("Input file open failure.(%s)\n", pInpPath);
		fErr = TRUE;
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	̓t@C̉s^Cv`FbN																			//
//--------------------------------------------------------------------------------------------------------------//
static	LFTYPE	ChkInpLfType(C_BCP pPath)
{
	LFTYPE	rc = TYPE_UNKOWN;
	HANDLE	fh;
	UB		rxc;
	UI		bytes;

	fh = CreateFile(pPath, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (fh != INVALID_HANDLE_VALUE) {
		while (ReadFile(fh, &rxc, 1, &bytes, NULL) && bytes == 1) {
			if		(rxc == '\r') {
				if (ReadFile(fh, &rxc, 1, &bytes, NULL) && bytes == 1) {
					if (rxc == '\n') {
						rc = TYPE_CRLF;
						break;
					}
					else {
						rc = TYPE_CR;
						break;
					}
				}
				else {
					break;
				}
			}
			else if (rxc == '\n') {
				rc = TYPE_LF;
				break;
			}
		}
		CloseHandle(fh);
	}
	return rc;
}
