#pragma warning(disable:4996)
#include	<AjrCst32.h>
#include	<stdio.h>

//--------------------------------------------------------------------------------------------------------------//
//	t@C^C																								//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	FILETIME  ft;
	long long v;
} UFT;
//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	int		nTab  = 4;					//	^uXebv
static	BOOL	fErr  = FALSE;				//	G[tO
static	UFT		fmk, fac, fup;				//	t@C^C
//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	void	ConvertTabToSpace(C_BCP pInpPath);

//--------------------------------------------------------------------------------------------------------------//
//	m a i n																										//
//--------------------------------------------------------------------------------------------------------------//
int main(int argc, char *argv[])
{
	int		i;

	//	vt@CWXg
	AjcSetProfileIsRegistory(TRUE);
	//	ftHg^uXebvǂݏo
	nTab = AjcGetProfileUInt("Param", "nTab", 4);

	//	̏ꍇ͐\
	if (argc == 1) {
		printf("\n");
		printf("--- Convert tabs in text file to blanks --------------------------------\n\n");
		printf("  Command format : deTab [/{2|4|8}] <TextFile1> [TextFile2] ...\n\n");
		printf("  Parameters     : /2 : TAB step = 2\n");
		printf("                   /4 : TAB step = 4(default)\n");
		printf("                   /8 : TAB step = 8\n\n");
		printf("  Note           : Directory can not be specified.\n\n");
		printf("  Registory      : Path = HKEY_CURRENT_USER\\Software\\AjrCst32\\deTab\\Param\n");
		printf("                   nTab = Default tab step\n");
		printf("\n--- Hit ENTER key ---");
		getchar();
	}
	//	L̏ꍇ́As`a󔒕ϊ
	else if (argc >= 2) {
		for (i = 1; i < argc; i++) {
			//	p^ݒ
			if (*argv[i] == '/') {
				if		(stricmp(argv[i], "/2") == 0) nTab	 = 2;
				else if (stricmp(argv[i], "/4") == 0) nTab	 = 4;
				else if (stricmp(argv[i], "/8") == 0) nTab	 = 8;
			}
			//	s`a󔒕ϊ
			else {
				ConvertTabToSpace(argv[i]);
			}
		}
	}

	//	ftHg^uXebv
	AjcPutProfileUInt("Param", "nTab", nTab);

	//	G[́Aꎞ~
	if (fErr) {
		printf("\n--- Hit enter key ---");
		getchar();
	}

	return 0;
}


//--------------------------------------------------------------------------------------------------------------//
//	s`a󔒕ϊ																							//
//--------------------------------------------------------------------------------------------------------------//
void	ConvertTabToSpace(C_BCP pInpPath)
{
	HAJCFILE	hInp = NULL;
	HAJCFILE	hOut = NULL;
	EAJCTEC		tec  = AJCTEC_MBC;
	BOOL		bom  = FALSE;
	UFT			fmk, fac, fup;
	UI			att;
	int			i, col;
	BC			buf[16384];
	BC			OutPath[MAX_PATH] = {0};

	//	o̓e|t@Cݒ
	GetTempPath(MAX_PATH, OutPath);
	strcat(OutPath, "deTAB.txt");
	//	̓t@C̑擾
	att = GetFileAttributes(pInpPath);
	//	̓eLXgt@CI[v
	if (hInp = AjcFOpen(pInpPath, AJCTEC_AUTO)) {
		//	̓t@C̃^CX^v擾
		GetFileTime(AjcFGetFileHandle(hInp), &fmk.ft, &fac.ft, &fup.ft);
		//	̓t@C̃eLXgGR[hƂanl̗L擾
		tec = AjcFGetTec(hInp);
		bom = AjcFGetBOM(hInp);
		//	o̓e|t@C
		if (hOut = AjcFCreate(OutPath, tec, bom)) {
			//	̓t@Ĉs`a󔒂ɕϊt@Co
			while (AjcFGetS(hInp, buf, sizeof buf)) {
				col = 0;
				for (i = 0; buf[i] != 0; i++) {
					if (buf[i] == 0x09) {
						do {
							AjcFPutC(hOut, ' ');
							col++;
						} while ((col % nTab) != 0);
					}
					else {
						AjcFPutC(hOut, buf[i]);
						col++;
					}
				}
			}
			AjcFClose(hInp);
		}
		else {
			printf("Temporary file creation failure.(%s)\n", pInpPath);
			fErr = TRUE;
		}
		//	o̓e|t@C̃^CX^vݒ
		SetFileTime(AjcFGetFileHandle(hOut), &fmk.ft, &fac.ft, &fup.ft);
		//	o̓e|t@C N[Y
		AjcFClose(hOut);
		//	Rs[eLXgt@C̑uʏt@Cvɐݒ
		SetFileAttributes(pInpPath, FILE_ATTRIBUTE_NORMAL);
		//	o̓e|t@CeLXgt@C֏㏑Rs[
		if (CopyFile(OutPath, pInpPath, FALSE) != 0) {
			//	eLXgt@C̑񕜐ݒ
			SetFileAttributes(pInpPath, att);
		}
		else {
			printf("Can not generate converted file.(%s)\n", pInpPath);
			fErr = TRUE;
		}
		//	o̓e|t@C폜
		DeleteFile(OutPath);
	}
	else {
		printf("Input file open failure.(%s)\n", pInpPath);
		fErr = TRUE;
	}
}
