#pragma warning(disable:4996)
#include	<AjrCst32.h>
#include	<stdio.h>

//--------------------------------------------------------------------------------------------------------------//
//	t@C^C																								//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	FILETIME  ft;
	long long v;
} UFT;
//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	int		nTab  = 4;					//	^uXebv
static	BOOL	fErr  = FALSE;				//	G[tO

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	void	ConvertSpaceToTab(C_BCP pInpPath);
static	BOOL	IsSpaces(C_BCP p, int n);

//--------------------------------------------------------------------------------------------------------------//
//	m a i n																										//
//--------------------------------------------------------------------------------------------------------------//
int main(int argc, char *argv[])
{
	int		i;

	//	vt@CWXg
	AjcSetProfileIsRegistory(TRUE);
	//	ftHg^uXebvǂݏo
	nTab = AjcGetProfileUInt("Param", "nTab", 4);

	//	̏ꍇ͐\
	if (argc == 1) {
		printf("\n");
		printf("--- Convert blank in text file to TABs --------------------------------\n\n");
		printf("  Command format : enTab [/{2|4|8}] <TextFile1> [TextFile2] ...\n\n");
		printf("  Parameters     : /2 : TAB step = 2\n");
		printf("                   /4 : TAB step = 4(default)\n");
		printf("                   /8 : TAB step = 8\n\n");
		printf("  Note           : Directory can not be specified.\n");
		printf("                 : Spaces in string are not converted to tabs.\n");
		printf("                 : If there is only one space it will not be converted to tabs.\n\n");
		printf("  Registory      : Path = HKEY_CURRENT_USER\\Software\\AjrCst32\\enTab\\Param\n");
		printf("                   nTab = Default tab step\n");
		printf("\n--- Hit ENTER key ---");
		getchar();
	}
	//	L̏ꍇ́A󔒁s`aϊ
	else if (argc >= 2) {
		for (i = 1; i < argc; i++) {
			//	p^ݒ
			if (*argv[i] == '/') {
				if		(stricmp(argv[i], "/2") == 0) nTab	 = 2;
				else if (stricmp(argv[i], "/4") == 0) nTab	 = 4;
				else if (stricmp(argv[i], "/8") == 0) nTab	 = 8;
			}
			//	s`a󔒕ϊ
			else {
				ConvertSpaceToTab(argv[i]);
			}
		}
	}

	//	ftHg^uXebv
	nTab = AjcPutProfileUInt("Param", "nTab", nTab);

	//	G[́Aꎞ~
	if (fErr) {
		printf("\n--- Hit enter key ---");
		getchar();
	}

	return 0;
}

//--------------------------------------------------------------------------------------------------------------//
//	bꎚ啪pR[obN																				//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbCtkRead(BCP pBuf, UI lBuf, UX xp)
{
	return (AjcFGetS((HAJCFILE)xp, pBuf, lBuf) != NULL);
}
//--------------------------------------------------------------------------------------------------------------//
//	󔒁s`aϊ																							//
//--------------------------------------------------------------------------------------------------------------//
void	ConvertSpaceToTab(C_BCP pInpPath)
{
	HAJCTK		hCtk = NULL;
	EAJCTKCODE	tkn;
	HAJCFILE	hInp = NULL;
	HAJCFILE	hOut = NULL;
	EAJCTEC		tec  = AJCTEC_MBC;
	BOOL		bom  = FALSE;
	UFT			fmk, fac, fup;
	UI			att;
	int			col, stl;
	BC			buf[16384];
	BC			OutPath[MAX_PATH] = {0};

	//	o̓e|t@Cݒ
	GetTempPath(MAX_PATH, OutPath);
	strcat(OutPath, "enTAB.txt");
	//	̓t@C̑擾
	att = GetFileAttributes(pInpPath);
	//	̓eLXgt@CI[v
	if (hInp = AjcFOpen(pInpPath, AJCTEC_AUTO)) {
		//	̓t@C̃^CX^v擾
		GetFileTime(AjcFGetFileHandle(hInp), &fmk.ft, &fac.ft, &fup.ft);
		//	̓t@C̃eLXgGR[hƂanl̗L擾
		tec = AjcFGetTec(hInp);
		bom = AjcFGetBOM(hInp);
		//	啪CX^X
		if (hCtk = AjcCtkCreate(AJCTKFLG_INCSPACE | AJCTKFLG_LBF_16K, cbCtkRead, (UX)hInp)) {
			col = 0;
			//	o̓e|t@C
			if (hOut = AjcFCreate(OutPath, tec, bom)) {
				//	̓eLXgt@C̋󔒂s`aɕϊďo
				while (AjcCtkGetToken(hCtk, buf, sizeof buf)) {
					BCP	p = buf;
					tkn = AJCTK_TOKEN(hCtk);
					stl = (int)strlen(buf);
					//	󔒁^RǵAQȏ̘A󔒂s`aɕϊďo
					if (tkn == EAJCTK_SPACE || tkn == EAJCTK_COMMENT || tkn == EAJCTK_LINECOMMENT) {
						BCP  p = buf;
						while (*p != 0) {
							//	^uȂ΂̂܂܏o͂AʒuXV
							if (*p == '\t') {
								AjcFPutC(hOut, '\t');
								col = (col - (col % nTab)) + nTab;
								p++;
							}
							//	^uȊOȂ΁AA󔒂s`aɕϊďo
							else {
								int rem = nTab - (col % nTab);
								//	A󔒂Ȃ΁As`ao
								if (rem > 1 && IsSpaces(p, rem)) {
									AjcFPutC(hOut, '\t');
									col += rem;
									p	+= rem;
								}
								//	A󔒈ȊOȂ΁AYo
								else {
									AjcFPutC(hOut, *p);
									col++;
									p++;
								}
							}
						}
					}
					//	̑ijȂ΁As`aɕϊȂł̂܂܏o
					else {
						AjcFPutS(hOut, buf, stl);
						col += stl;
					}
					//	sȂ΁Aʒu
					if (tkn == EAJCTK_EOL) {
						col = 0;
					}
				}
				//	̓eLXgt@CN[Y
				AjcFClose(hInp);
			}
			else {
				printf("Temporary file creation failure.(%s)\n", pInpPath);
				fErr = TRUE;
			}
			//	o̓e|t@C̃^CX^vݒ
			SetFileTime(AjcFGetFileHandle(hOut), &fmk.ft, &fac.ft, &fup.ft);
			//	o̓e|t@C N[Y
			AjcFClose(hOut);
			//	Rs[eLXgt@C̑uʏt@Cvɐݒ
			SetFileAttributes(pInpPath, FILE_ATTRIBUTE_NORMAL);
			//	o̓e|t@CeLXgt@C֏㏑Rs[
			if (CopyFile(OutPath, pInpPath, FALSE) != 0) {
				//	eLXgt@C̑񕜐ݒ
				SetFileAttributes(pInpPath, att);
			}
			else {
				printf("Can not generate converted file.(%s)\n", pInpPath);
				fErr = TRUE;
			}
			//	啪CX^X
			AjcCtkDelete(hCtk);
			//	o̓e|t@C폜
			DeleteFile(OutPath);
		}
		else {
			printf("Can not create CTK.(%s)\n", pInpPath);
			fErr = TRUE;
		}
	}
	else {
		printf("Input file open failure.(%s)\n", pInpPath);
		fErr = TRUE;
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	A󔒃`FbN																						//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	IsSpaces(C_BCP p, int n)
{
	BOOL	rc = TRUE;
	int		i;

	for (i = 0; i < n; i++, p++) {
		if (*p != ' ') {
			rc = FALSE;
			break;
		}
	}
	return rc;
}
