#pragma warning(disable:4996)
#include	<AjrCst32.h>
#include	<stdio.h>
#include	<stdlib.h>

int main(int argc, char *argv[])
{
	BOOL		fErr  = FALSE;
	HAJCFILE	hInp = NULL;
	HAJCFILE	hOut = NULL;
	EAJCTEC		tec  = AJCTEC_MBC;
	BOOL		bom  = FALSE;
	int			lno, i, col;
	BOOL		fDeTab = TRUE;
	int			nTab  = 4;
	char		buf[16384];
	char		InpPath[MAX_PATH] = {0};
	char		OutPath[MAX_PATH] = {0};
	char		OutDir[MAX_PATH]  = {0};
	char		OutFile[MAX_PATH] = {0};
	char		drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];

	//	vt@CWXg
	AjcSetProfileIsRegistory(TRUE);
	//	ftHg^uXebvǂݏo
	nTab = AjcGetProfileUInt("Param", "nTab", 4);
	if (nTab == 0) fDeTab = FALSE;

	//	̏ꍇ͐\
	if (argc == 1) {
		printf("\n");
		printf("--- Add line number and change TAB to SPACE -----------------------------------\n\n");
		printf("  Command format : PlusLine [/{0|2|4|8}] <TextFile>\n\n");
		printf("  Parameters     : /0 : Not change TAB to SPACE\n");
		printf("                   /2 : TAB step = 2\n");
		printf("                   /4 : TAB step = 4(default)\n");
		printf("                   /8 : TAB step = 8\n\n");
		printf("  Note           : Only one text file can be specified.\n");
		printf("                   Create \"plusline.txt\" in the temporary directory and open it.\n\n");
		printf("  Registory      : Path = HKEY_CURRENT_USER\\Software\\AjrCst32\\PlusLine\\Param\n");
		printf("                   nTab = Default tab step\n");
		printf("\nHit ENTER key -");
		getchar();
	}
	//	L̏ꍇ́AsԍtƂs`a󔒕ϊe|t@C֏o
	else if (argc >= 2) {
		for (i = 1; i < argc; i++) {
			if (*argv[i] == '/') {
				if		(stricmp(argv[i], "/0") == 0) fDeTab = FALSE;
				else if (stricmp(argv[i], "/2") == 0) nTab	 = 2;
				else if (stricmp(argv[i], "/4") == 0) nTab	 = 4;
				else if (stricmp(argv[i], "/8") == 0) nTab	 = 8;
			}
			else {
				if (InpPath[0] == 0) {
					_snprintf(InpPath, sizeof InpPath, "%s", argv[i]);
					InpPath[sizeof InpPath - 1] = 0;
				}
				else {
					printf("More than one file was specified.\n");
					fErr = TRUE;
					goto main_exit;
				}
			}
		}
		if (InpPath[0] != 0) {
			//	o̓e|t@Cݒ
			GetTempPath(MAX_PATH, OutPath);
			strcat(OutPath, "plusLine.txt");
			//	̓eLXgt@CI[v
			if (hInp = AjcFOpen(InpPath, AJCTEC_AUTO)) {
				//	̓t@C̃eLXgGR[hƂanl̗L擾
				tec = AjcFGetTec(hInp);
				bom = AjcFGetBOM(hInp);
				//	o̓e|t@C
				if (hOut = AjcFCreate(OutPath, tec, bom)) {
					//	sԍtƂs`a󔒕ϊe|t@C֏o
					lno = 0;
					while (AjcFGetS(hInp, buf, sizeof buf)) {
						if (fDeTab) {
							AjcFPrintF(hOut, "%5u : ", ++lno);
							col = 0;
							for (i = 0; buf[i] != 0; i++) {
								if (buf[i] == 0x09) {
									do {
										AjcFPutC(hOut, ' ');
										col++;
									} while ((col % nTab) != 0);
								}
								else {
									AjcFPutC(hOut, buf[i]);
									col++;
								}
							}
						}
						else {
							AjcFPrintF(hOut, "%5u : %s", ++lno, buf);
						}
					}
					//	o̓e|t@C N[Y
					AjcFClose(hOut);
					//	o̓e|t@CJ
					_splitpath(OutPath, drv , dir , fname, fext);
					_makepath (OutDir , drv , dir , NULL , NULL);
					_makepath (OutFile, NULL, NULL, fname, fext);
					ShellExecute(NULL, "open", OutFile, NULL, OutDir, SW_SHOW);
				}
				else {
					printf("Temporary file creation failure.\n");
					fErr = TRUE;
				}
				AjcFClose(hInp);
			}
			else {
				printf("Text file open failure.\n");
				fErr = TRUE;
			}
		}
	}

main_exit:;

	//	ftHg^uXebv
	nTab = AjcPutProfileUInt("Param", "nTab", nTab);

	//	G[́Aꎞ~
	if (fErr) {
		printf("\n--- Hit enter key ---");
		getchar();
	}

	return 0;
}
